package extensions;
import java.io.IOException;
import java.io.File;
import java.nio.channels.FileChannel;
import java.io.InputStreamReader;
import java.io.FileReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.BufferedReader;
import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.StringReader;
import java.nio.ByteBuffer;
import java.util.Locale;
import java.util.Map;
import java.util.Random;
import java.util.HashSet;
import java.util.ArrayList;
import java.util.TreeSet;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.zip.GZIPInputStream;
import java.util.zip.InflaterInputStream;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;
import java.util.concurrent.ConcurrentHashMap;
import java.net.URL;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.net.Socket;
import dareka.common.Logger;
import dareka.common.CloseUtil;
import dareka.common.FileUtil;
import dareka.common.DiskFreeSpace;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.extensions.Rewriter;
import dareka.extensions.RequestFilter;
//import dareka.extensions.CompleteCache;
import dareka.processor.Processor;
import dareka.processor.Resource;
import dareka.processor.URLResource;
import dareka.processor.StringResource;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.TransferListener;
import dareka.processor.TemporaryFileResource;
//import dareka.processor.impl.Cache;
//import dareka.processor.impl.MovieIdSorter;
/** YouTubeLbV */
public class YouTubeCacheExtension implements Extension2,Processor,TransferListener,Rewriter/*,RequestFilter,CompleteCache*/,Runnable{
	/** Extensioñ^Cg1 */
	private final String EXTENSION_TITLE1 = "YouTubeCacheExtension";
	/** Extensioño[W */
	private final String EXTENSION_VERSION = "v04d";
	/** Processor URL*/
	private final Pattern PATTERN_PROCESSOR_SUPPORTED = Pattern.compile(
		"^http://[^\\&]+youtube\\.com/get_video\\?video_id=([^\\&]+)\\&ip=" +
//URL͊ԈႢō͉Bǃ}b`Ă͍邱Ƃ̂ł̂܂܂ɂĂ
//		"|^ttp://[^\\&]+youtube\\.com/get_video\\?[^\\#]+video_id=([^\\&]+)\\&?"
		"|^http://[^\\&]+googlevideo\\.com/get_video\\?[^\\#]+\\&video_id=([^\\&]+)\\&" +
		"|^http://[^\\&]+googlevideo\\.com/videoplayback\\?[^\\#]+id=([^\\&]+)" +
		"|^http://[^\\&]+c\\.youtube\\.com/videoplayback\\?[^\\#]+id=([^\\&]+)" +
		"|^http://www\\.nicovideo\\.jp/"+cachePage+"/(.*)$" +
		"|^http://[^\\.]+\\.youtube\\.com/v/([\\w\\-]+).*$" +
		"|^http://[^\\.]+\\.youtube\\-nocookie\\.com/v/([\\w\\-]+).*$" +
		"");
	/** Rewriter URL */
	private static final Pattern PATTERN_REWRITER_SUPPORTED = Pattern.compile(
		"^http://[^\\.]+\\.youtube\\.com/watch(.+)$" +
		""
	);
	/** ExtensionNicoCache_nl{̂ɓo^ */
	public void registerExtensions(ExtensionManager mgr) {
		// Kvȍŝ݃RgO
		mgr.registerProcessor(this);      // ProcessorƂēo^
		mgr.registerRewriter(this);       // RewriterƂēo^
//		mgr.registerRequestFilter(this);  // RequestFilterƂēo^
//		mgr.registerCompleteCache(this);  // CompleteCacheƂēo^
	}
	/** Extensioño[W */
	public String getVersionString() {return EXTENSION_TITLE1 + " " + EXTENSION_VERSION;}
	/** Processor ̃\bh(Get or Post) */
	public String[] getSupportedMethods() {return new String[] { "GET", "POST" };}
	/** Processor URLԂ\bh*/
	public Pattern getSupportedURLAsPattern() {return PATTERN_PROCESSOR_SUPPORTED;}
	/** Processor getSupportedURLAsPattern()nullȂ炱ꂪĂ΂ nullȂSĂURLɃ}b` */
	public String getSupportedURLAsString() {return null;}
	/** Rewriter URLԂ\bh */
	public Pattern getRewriterSupportedURLAsPattern() {return PATTERN_REWRITER_SUPPORTED;}
	/** ProcessorponRequest
	 * @param requestHeader NGXg̃wb_
	 * C AEgoEh(T[o)ɑMwb_ɔf
	 * @param browser Socket[addr,port,localport]
	 * @return X|XƂĕԂ\[X
	 */
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)throws IOException{return userRequest(requestHeader,browser);}
	/** RewriterponMatch
	 * @param match }b`ɎgpMatcher
	 * @param responseHeader X|Xwb_
	 * @param content MReciɏĂ\j
	 * @return Rec
	 */
	public String onMatch(Matcher match, HttpResponseHeader responseHeader, String content)throws IOException{return userRequest(match,responseHeader,content);}
	/** RequestFilterponMatch
	 * NGXgProcessorŏOɌĂ΂
	 * @param requestHeader ĂNGXgwb_
	 * @return ƂȂintԂėpł悤ɂBIȂ 0 Ԃ G[Ȃ1Ԃ
	 */
	//public int onRequest(HttpRequestHeader requestHeader)throws IOException{return userRequestFilter(requestHeader);}
	/** CompleteCacheExtension̗D揇( 0` )
	 * @return f[^擾݂̂ȂǁALbVړAKExtensionɉ񂷏ꍇ͕̒lݒ
	 */
	//public int getPriority() {return -1;}
	/** onCompleteĂ΂钼OAĂяo肷ۂɌĂ΂
	 * Őݒt@C̓Iǂݍ݂Apriority̐ݒ
	 * (onCompleteĂ΂Ƃɂ́Ałɏ肵Ă̂ŁA Iǂݍ݂priority̐ݒ肪ɔfȂ)
	 * XbhZ[tȎKv
	 */
	//public void update() {}
    /** LbVɌĂ΂
     * @param Cache jRCacheNX
	 * @return LbVړtrueAȂƂfalseԂ
	 * trueԂ́AȌCompleteCacheExtension͌Ă΂ȂBXbhZ[tȎKv
     * @throws IOException
     */
	//public boolean onComplete(Cache cache) throws IOException{return false;}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
	/** RXgN^*/
	public YouTubeCacheExtension(){
		String cacheFolder = System.getProperty("ytc_cacheFolder");
		if(cacheFolder.equals("")){
			cacheFolder = cachePage;//ݒ肵ĂȂftHĝg
		}
		//cacheFolder = cacheFolder.replaceAll("\\\\","/");
		cacheDir = new File(cacheFolder);//tH_o^
		cacheDirString = "\\Q"+cacheFolder+"\\E";//K\
		//-----------------------------------------------------------------------
		cacheDir.mkdir();//LbVtH_쐬 ݂΍쐬ꂸfalseԋpBԂlfȂ̂Ŋ֌WȂ
		initYouTubeCache(true);//T
		makeIdList();//fileɏo
		tmpCacheSize = (long)allCacheList.size();//LbVLĂ
		//-----------------------------------------------------------------------
		//ȉOp
		//-----------------------------------------------------------------------
		logWindow("Log Start");
		logWindow("Extension Title: " + EXTENSION_TITLE1 + " " + EXTENSION_VERSION);
//		logWindow("cacheDir: " + cacheDir.getAbsolutePath());
		logWindow("CacheSize: " + allCacheList.size());
		logWindow("----------");
	}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
	/** tH_̋؂ */
    private static final String FS = System.getProperty("file.separator");
	/** IDListt@C̏ꏊ */
	private final File YCIdFile = new File("./list/youtubeIdList.txt");
	/** nl̐ݒt@C̏ꏊ */
	private final File PropFile = new File("./config.properties");
	//*******************************************************************************************************************
	/** LbVtH_ */
	private static File cacheDir = new File("cache_youtube");
	/** LbVtH_̕ */
	private static String cacheDirString = "cache_youtube";
	/** LbVǗy[WURL */
	private static final String cachePage = "cache_youtube";
	/** LbVۑtH_ */
	private static final String NLTMP = "tmp_";
	/** fmt̐ړBȂɂw肷邱ƁBȂ݂ɉłok */
	private static final String NLFMT = "f";
	/** idƃ^Cg̋؂蕶B_͎gȂ̂ŎbB(a-zA-Z_-)ȊOw肷邱ƁBȂ݂ɉłok*/
	private static final String NLPOS = "#";
	/** fmtlist */
	private int[] flagFmtList = new int[8];
	/** links */
	private String[] flagManagerLinks = new String[4];
	/** cache size */
	private Long tmpCacheSize = 0l;
	//*******************************************************************************************************************
	/** config.propertieslastModifiedۑp */
	private long LastModifiedCofigProp = 0;
	/** LbVtH_lastModifiedۑp */
	private long LastModifiedCacheForder = 0;
	//*******************************************************************************************************************
	/** vididƃ^CgۑBdlI珇폜 */
	private static ConcurrentHashMap<String, String> cacheid = new ConcurrentHashMap<String, String>();
	/** _E[hǂ */
	private static ConcurrentHashMap<String, Long> cache_downloading = new ConcurrentHashMap<String, Long>();
	/** LbVꗗ */
	private static ConcurrentHashMap<String, File> allCacheList = new ConcurrentHashMap<String, File>();
	/** ꎞLbVꗗ */
	private static ConcurrentHashMap<String, File> allTmpCacheList = new ConcurrentHashMap<String, File>();
	/** LbVtH_ꗗ */
	private ArrayList<String> allFolderList = new ArrayList<String>();
	/** Os */
	private static Integer LogCount = 0;
	/** Oobt@*/
	private static StringBuilder LogBuffer = new StringBuilder();
	/** RunnablepThread */
	private volatile Thread thread = null;
	//*******************************************************************************************************************
	// logp
	//*******************************************************************************************************************
	/** log\p̃\bh
	 * @param mes \IuWFNg(  tO)
	 */
	private void logInfo(Object mes){Logger.info("ytc: " + mes);}
	/** Oʕ\p
	 * @param mes \IuWFNg
	 */
	private void logWindow(Object mes){
		LogCount += 1;
		LogBuffer.append(String.format("%04d",LogCount) + " [" + convertUnixtime(-1l,2) + "] " + mes + "\n");
		if(LogCount > 500){//500𒴂Â̂폜
			LogBuffer.delete(0,LogBuffer.indexOf("\n") + 1);
		}
	}
	/** O\p
	 * @param mes \IuWFNg
	 */
	private void logMulti(Object mes){
		logWindow(mes);
		logInfo(mes);
	}
	/** fobNO\p
	 * @param mes \IuWFNg
	 */
	private void logDebug(Object mes){
		if(Boolean.getBoolean("ytc_debug")){
			logInfo("[debug]: " + mes);
		}else{
			//
		}
	}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
	/** ANZXɍs */
	private void initialize(){
		long st = System.currentTimeMillis();
		initYouTubeCache(false);//SLbVT
		if(System.currentTimeMillis() != st)
			logDebug("initialize time1: " + (System.currentTimeMillis() - st) + "msec");
		initFlag();				//tO
		if(System.currentTimeMillis() != st)
			logDebug("initialize time2: " + (System.currentTimeMillis() - st) + "msec");
		initIdList();			//IdListp
		if(System.currentTimeMillis() != st)
			logDebug("initialize time3: " + (System.currentTimeMillis() - st) + "msec");
	}
	/** IdListpopɒׂ */
	private void initIdList(){
		//DLׂ
		if(cache_downloading.size() != 0){
			//DLĂ珑oȂ
			return;
		}
		long s = allCacheList.size();
		//ȑÕLbVƍ̃LbVׂ
		if(tmpCacheSize == s){
			//LbVȂ̂ŏȂ
			return;
		}
		//LbVႤ
		//LbVLĂ
		tmpCacheSize = s;
		//idlisto
		makeIdList();
	}
	/** ݒǂݍ */
	private void initFlag(){
		long lastmod = PropFile.lastModified();
		if(lastmod == 0){//ʏ킠肦Ȃ
			return;
		}else if (lastmod <= LastModifiedCofigProp){//XVȂ
			return;
		}else{//XV
		}
		LastModifiedCofigProp = lastmod;
		//--------------------------------------------------------------------
		//`FbNJn
		//--------------------------------------------------------------------
		String fmtlist = System.getProperty("ytc_CachePriority");
		if(fmtlist.equals("High")){
			flagFmtList = new int[]{38,37,22,35,18,34,6,5};
		}else if(fmtlist.equals("Low")){
			flagFmtList = new int[]{5,6,34,18,35,22,37,38};
		}else{
			flagFmtList = new int[8];
			String[] list = fmtlist.replaceAll("\\s","").split(",");
			for(int i=0;i<list.length;i++){
				flagFmtList[i] = parseStringInteger(list[i]);
				if(i>7){
					break;
				}
			}
		}
		//--------------------------------------------------------------------
		String linklist = System.getProperty("ytc_ManagerLinks");
		if(linklist.contains(",")){
			flagManagerLinks = linklist.split(",");
			logDebug("[link]: "+linklist);
		}else{
			flagManagerLinks = new String[0];
		}
		//--------------------------------------------------------------------
		//--------------------------------------------------------------------
		if(Boolean.getBoolean("ytc_debug")){
			StringBuilder sb = new StringBuilder(20+10);
			for(int i:flagFmtList){
				sb.append(i+",");
			}
			logDebug("[fmt]: "+sb.toString());
			sb = null;
		}
	}
	//*******************************************************************************************************************
	// Rewriter
	//*******************************************************************************************************************
	/** Rewriter̃C
	 * @param match }b`ɎgpMatcher
	 * @param responseHeader X|Xwb_
	 * @param content MRec
	 * @return RecB
	 */
	private String userRequest(Matcher match,HttpResponseHeader responseHeader,final String content){
		logWindow("watch:URL: " + match.group());
		//initialize()̂قꐫ邪AꂵKvȂB
		//IdListoB
		initIdList();
		//
		Pattern pat =  Pattern.compile("[\\?\\&]v=([^\\&]+)");//?v=<id>,&v=<id>ɑΉĂ
		Matcher m = pat.matcher(match.group(1));
		String vid = null;
		if(m.find()){
			vid = m.group(1);
		}
		if(vid == null){//Ȃɂ\
			logWindow("watch:URL:vid: Failed. /"+match.group(1));
			return content;
		}
		//id
		pat =  Pattern.compile("id=(\\w+)[,\"']");
		m = pat.matcher(content);
		String id = null;
		String title = null;
		if(m.find()){
			id = m.group(1);//id擾
		}
		//^Cg
		pat =  Pattern.compile("<title>\\s*\\S+\\s+\\S\\s+(.+)\\s+</title>",Pattern.DOTALL);
		m = pat.matcher(content.replaceAll("\\r|\\n",""));
		if(m.find()){
			title = m.group(1);//^Cg擾
		}
		//idnullȂȂɂ
		if(id == null){
			id = vid;
			//return content;
		}
		//^CgnullȂunknownɂ
		if(title == null){
			title = "unknown";
		}
		String fmt = null;
		pat =  Pattern.compile("\"fmt_list\"\\s*:\\s*\"([^\"]+)\"");
		m = pat.matcher(content);
		if(m.find()){
			fmt = m.group(1);//̓̉𑜓xꗗ擾
		}
		String fmtmap = null;
		pat =  Pattern.compile("\"fmt_url_map\"\\s*:\\s*\"(\\d+)");
		m = pat.matcher(content);
		if(m.find()){
			fmtmap = m.group(1);//̓̉𑜓x擾
		}
		//logInfo(vid + "," + id+"/"+title);
		//
		logWindow("watch: " + vid + " / " + id + " / " + title + " / f:" + fmtmap + " / (" + fmt + ")");
		//idvidƃ^Cgo^B
		cacheid.put(id,vid+"<>"+fileEscape(title));
		return content;
	}
	/** t@CƂĂ̂GXP[v
	 * @param title GXP[v镶
	 * @return 
	 */
	private String fileEscape(String title){
		return title.replaceAll("<","(").replaceAll(">",")")
					.replaceAll(":","_").replaceAll("\"","'")
					.replaceAll("/","_").replaceAll("\\\\","_")
					.replaceAll("\\|","_").replaceAll("\\?","_")
					.replaceAll("\\*","_");
	}
	//*******************************************************************************************************************
	//Processor
	//*******************************************************************************************************************
	/** Processor̃C
	 * @param requestHeader NGXg̃wb_BC AEgoEh(T[o)ɑMwb_ɔf
	 * @param browser Socket[addr,port,localport]
	 * @return X|XƂĕԂ\[X
	 */
	private Resource userRequest(HttpRequestHeader requestHeader, Socket browser) throws IOException {
		//ANZXURL
		String aurl = requestHeader.getURI();
		Matcher m = PATTERN_PROCESSOR_SUPPORTED.matcher(aurl);
		//logInfo(requestHeader.getMessageHeader("Referer"));
		//logInfo(requestHeader.toString());
		if (!m.find()) {
			//ʏ킱ɂ͂Ȃ͂
			//jRpĂ̂ł`FbN邱Ƃɂ
			//logDebug("Error?: "+aurl);
			return Resource.get(Resource.Type.URL,aurl);
		}
		//
		initialize();
		//LbVǗɔ΂
		if(aurl.startsWith("http://www.nicovideo.jp/"+cachePage+"/")){//24
			String path = aurl.substring(24);//.jp/܂ł؂
			//logWindow("LocalTubeFlv");
			//؂̂玟/܂ł؂
			return tRequest(path.substring(path.indexOf("/")+1),requestHeader);
		}
		//Ov[[p̂Ƃɔ΂
		if(
			aurl.startsWith("http://www.youtube.com/v/") ||
			aurl.startsWith("http://www.youtube-nocookie.com/v/")
		){
			String id = m.group(6) != null ? m.group(6) : m.group(7);
			embedCheckIdTitle(id,requestHeader);
			return Resource.get(Resource.Type.URL, requestHeader.getURI());
		}
		//
		logWindow("movieurl: " + convertURLDecoder(aurl));
		//logInfo(m.group(1) + "/" + m.group(2) + "/" + m.group(3) + "/" + m.group(4) + "/");
		//ǂꂩidĂ
		String id = m.group(1) != null ? m.group(1) : m.group(2) != null ?  m.group(2) : m.group(3) != null ? m.group(3) : m.group(4);
		String fmtid = "";
		//URLfmtԍ擾
		Pattern pat = Pattern.compile("&itag=(\\d+)&");
		Matcher mf = pat.matcher(aurl);
		if(mf.find()){
			fmtid = mf.group(1);
		}
		String[] vid = new String[]{id,"",""};
		if(cacheid.containsKey(id)){//^Cgid擾
			vid = cacheid.get(id).split("<>");
		}else{
			//idtitleݒ肷̂ɎŝŃOɕ\ĂƂɂ
			logWindow("Error. Cache Id and Title Get Failed...");
		}
		File cfv = checkCacheFile(vid[0],false);
		File cfi = checkCacheFile(id,false);
//		logInfo("id: " + id + " /vid: " + vid[0] + " /title: " + vid[1] + "/fmt: "+fmtid);
//		if(cfv != null){
//			logInfo("v//" + vid[0] + "/" + cfv.getName());
//		}
//		if(cfi != null){
//			logInfo("i/" + id + "/" + cfi.getName());
//		}
		//LbVĂ邪Aid݂̂łASLbVȂ
		if(cfv == null && cfi != null){
			String f = cfi.getName();//t@C
			String pos = ".mp4";
			if(f.endsWith("mp4")){
				pos = ".mp4";
			}else{
				pos = ".flv";
			}
			//VO
			File newfile = new File(cacheDir,vid[0]+((fmtid==null||fmtid.equals(""))?"":NLFMT+fmtid)+((vid[1] == null || vid[1].equals(""))?"":NLPOS) + vid[1] + pos);
			//OύX
			if(changeFileName(cfi,newfile)){
				//
				logWindow("Cache ID and Title ReName.");
				return usingCacheResource(newfile,id,fmtid);
			}else{
				//O̕ύXɎŝŐVLbV邱Ƃɂ
			}
		//id݂̂̃LbVvid̃LbVĂ
		}else if(cfv != null && cfi != null){
			//Ȃ񂩏ȂƂȂ\
		}else{
			//
		}
		//LbVĂ
		if(cfv != null){
			return usingCacheResource(cfv,id,fmtid);
		}
		logWindow("id: " + id + " /vid: " + vid[0] + " /title: " + vid[1] + "/fmt: "+fmtid);
		YouTubeCacheExtension tc = new YouTubeCacheExtension(requestHeader,vid[0],vid[1],fmtid);
		return tc.getResource();
	}
	/** LbV݂
	 * @param usfile ǂݍރt@C
	 * @param id id
	 * @return Resource
	 * @throws IOException
	 */
	private Resource usingCacheResource(File usfile,String id,String fmt) throws IOException {
		Resource r = Resource.get(Resource.Type.URL,usfile.toURI().toString());
		r.setResponseHeader("Cache-Control", "no-cache");
		String f = usfile.getName();
		if(f.endsWith(".mp4")){//t@C̍Ōオmp4ȂcontentType
			r.setResponseHeader(HttpHeader.CONTENT_TYPE, "video/mp4");
		}else{
			r.setResponseHeader(HttpHeader.CONTENT_TYPE, "video/x-flv");
		}
		logWindow("using: Content-Type: " + (f.endsWith(".mp4") ? "video/mp4":"video/x-flv"));
		logMulti("using youtube cache found: " + f);
		//idۑĂƂ납폜
		if(id != null && !id.equals("")){//ꉞnull`FbN
			//폜̂͑̂Ƃ
			//cacheid.remove(id);
		}
		return r;
	}
	/** ߍݗpɃ^CgƂ擾
	 * @param vid vid
	 * @param requestHeader HttpRequestHeader
	 */
	private void embedCheckIdTitle(String vid,HttpRequestHeader requestHeader){
		if(vid == null || vid.equals("")){
			return;//s
		}
		//łɓo^Ă邩ׂ
		for (Map.Entry<String,String> e : cacheid.entrySet()) {
			if(e.getValue().startsWith(vid)){
				//o^Ă̂ŗ]vȃANZX͂Ȃ
				return;
			}
		}
		String str = getHttpRespons("http://www.youtube.com/watch?v="+vid,requestHeader,false);
		Pattern pat =  Pattern.compile("<title>\\s*\\S+\\s+\\S\\s+(.+)\\s+</title>",Pattern.DOTALL);
		Matcher m = pat.matcher(str.replaceAll("\\r|\\n",""));
		String title = null;
		//String movieurl = null;
		String id = null;
		if(m.find()){
			title = m.group(1);//^Cg擾
		}
/*
http%3A%2F%2Fv21.lscache2.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D604453D86695C5D88148C61AE48C137BC2747A68.2AD630B64E0718072C39B51B6BC075F568C7BEAD%26factor%3D1.25%26id%3Dbd9728ad84facede%2C5%7C
http%3A%2F%2Fv21.lscache2.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D604453D86695C5D88148C61AE48C137BC2747A68.2AD630B64E0718072C39B51B6BC075F568C7BEAD%26factor%3D1.25%26id%3Dbd9728ad84facede%7C%7Ctc.v21.cache2.c.youtube.com%2C5%7C
http%3A%2F%2Fv21.lscache2.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D604453D86695C5D88148C61AE48C137BC2747A68.2AD630B64E0718072C39B51B6BC075F568C7BEAD%26factor%3D1.25%26id%3Dbd9728ad84facede%2C5%7C
http%3A%2F%2Fv21.lscache2.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D604453D86695C5D88148C61AE48C137BC2747A68.2AD630B64E0718072C39B51B6BC075F568C7BEAD%26factor%3D1.25%26id%3Dbd9728ad84facede%7C%7Ctc.v21.cache2.c.youtube.com%2C5%7C
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DCE7D4A4D001F46B3402C363A15411EB6D051AD96.2A5D51F6007499578A6C776A66EC0A6C047F6AE2%26factor%3D1.25%26id%3Dbd9728ad84facede&csi_page_type=watch&keywords=%E4%BF%BA%E3%81%AE%E5%A6%B9%E3%81%8C%E3%81%93%E3%82%93%E3%81%AA%E3%81%AB%E5%8F%AF%E6%84%9B%E3%81%84%E3%82%8F%E3%81%91%E3%81%8C%E3%81%AA%E3%81%84%2C%E3%83%9D%E3%83%BC%E3%82%BF%E3%83%96%E3%83%AB%2CPV&rec_key=DF66A51BA851ADDA-38A61FBA85293009&rv.1.url=
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DCE7D4A4D001F46B3402C363A15411EB6D051AD96.2A5D51F6007499578A6C776A66EC0A6C047F6AE2%26factor%3D1.25%26id%3Dbd9728ad84facede%7C%7Ctc.v6.cache8.c.youtube.com&rv.2.rating=5.0&rv.7.title=%E3%80%90%E4%BF%BA%E3%81%AE%E5%A6%B9%E3%81%8C%E3%81%93%E3%82%93%E3%81%AA%E3%81%AB%E5%8F%AF%E6%84%9B%E3%81%84%E3%82%8F%E3%81%91%E3%81%8C%E3%81%AA%E3%81%84%E3%80%91%E3%82%80%E3%81%97%E3%82%8D%EF%BC%AF%EF%BC%B0%E7%8B%99%E3%81%84%EF%BC%88%E3%81%87&cr=JP&rv.1.id=Ee7tVUeeh2E&rv.6.title=%E4%BF%BA%E3%81%AE%E5%A6%B9%E3%81%8C%E3%81%93%E3%82%93%E3%81%AA%E3%81%AB%E5%8F%AF%E6%84%9B%E3%81%84%E3%82%8F%E3%81%91%E3%81%8C%E3%81%AA%E3%81%84PV&rv.4.length_seconds=61&record=1&rv.7.view_count=4478&rv.5.view_count=20270&length_seconds=46&feature=player_embedded&enablejsapi=1&rec_title=Re%3A+%E4%BF%BA%E3%81%AE%E5%A6%B9%E3%81%8C%E3%81%93%E3%82%93%E3%81%AA%E3%81%AB%E5%8F%AF%E6%84%9B%E3%81%84%E3%82%8F%E3%81%91%E3%81%8C%E3%81%AA%E3%81%84+%E3%83%9D%E3%83%BC%E3%82%BF%E3%83%96%E3%83%AB%E3%80%80PV&video_id=vZcorYT6zt4&plid=AASOQzj70JoBxuC5&rv.5.rating=5.0&rv.0.author=sweethead&rv.4.url=
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DCE7D4A4D001F46B3402C363A15411EB6D051AD96.2A5D51F6007499578A6C776A66EC0A6C047F6AE2%26factor%3D1.25%26id%3Dbd9728ad84facede&csi_page_type=watch&keywords=%E4%BF%BA%E3%81%AE%E5%A6%B9%E3%81%8C%E3%81%93%E3%82%93%E3%81%AA%E3%81%AB%E5%8F%AF%E6%84%9B%E3%81%84%E3%82%8F%E3%81%91%E3%81%8C%E3%81%AA%E3%81%84%2C%E3%83%9D%E3%83%BC%E3%82%BF%E3%83%96%E3%83%AB%2CPV&rec_key=DF66A51BA851ADDA-38A61FBA85293009&rv.1.url=
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DCE7D4A4D001F46B3402C363A15411EB6D051AD96.2A5D51F6007499578A6C776A66EC0A6C047F6AE2%26factor%3D1.25%26id%3Dbd9728ad84facede%7C%7Ctc.v6.cache8.c.youtube.com&rv.2.rating=5.0&
-------
http%3A%2F%2Fv11.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DBDDAF19D657EDFC043D129880849DAF8760D1986.3E2A3D55EB52770958363DD4D5CF7F1196960B1B%26factor%3D1.25%26id%3De8d2c5777f5cf765%2C5%7C
http%3A%2F%2Fv11.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DBDDAF19D657EDFC043D129880849DAF8760D1986.3E2A3D55EB52770958363DD4D5CF7F1196960B1B%26factor%3D1.25%26id%3De8d2c5777f5cf765%7C%7Ctc.v11.cache4.c.youtube.com%2C5%7C
http%3A%2F%2Fv11.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DBDDAF19D657EDFC043D129880849DAF8760D1986.3E2A3D55EB52770958363DD4D5CF7F1196960B1B%26factor%3D1.25%26id%3De8d2c5777f5cf765%2C5%7C
http%3A%2F%2Fv11.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3DBDDAF19D657EDFC043D129880849DAF8760D1986.3E2A3D55EB52770958363DD4D5CF7F1196960B1B%26factor%3D1.25%26id%3De8d2c5777f5cf765%7C%7Ctc.v11.cache4.c.youtube.com%2C5%7C
http%3A%2F%2Fv23.lscache6.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D490EF6494A52DD17CDE0F60322D332DE8C330230.6AEF0FB9400F835CD70C93FADDF4EDE2ABDFA7BF%26factor%3D1.25%26id%3De8d2c5777f5cf765&csi_page_type=watch&keywords=yumekui%2Cpv01&rec_key=F505D05C49C8D2FC-0B8DEB2F6DD9BDAF&rv.1.url=
http%3A%2F%2Fv23.lscache6.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D490EF6494A52DD17CDE0F60322D332DE8C330230.6AEF0FB9400F835CD70C93FADDF4EDE2ABDFA7BF%26factor%3D1.25%26id%3De8d2c5777f5cf765%7C%7Ctc.v23.cache6.c.youtube.com&rv.2.rating=5.0&rv.7.title=drawing+animation+SAND+CASTLE&cr=JP&rv.1.id=esci-6dsphg&rv.6.title=Jessika+-+4%2F4%E3%80%80Numazu+Wave&rv.4.length_seconds=292&record=1&rv.7.view_count=822&rv.5.view_count=51&length_seconds=71&enablejsapi=1&rec_title=Re%3A+%E5%A4%A2%E5%96%B0%E3%81%84%E3%83%A1%E3%83%AA%E3%83%BC+pv+19-08-2010&video_id=6NLFd39c92U&plid=AASOQ0w_GdW-nBjk&rv.5.rating=0.0&rv.0.author=wx9239&rv.4.url=
http%3A%2F%2Fv23.lscache6.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D490EF6494A52DD17CDE0F60322D332DE8C330230.6AEF0FB9400F835CD70C93FADDF4EDE2ABDFA7BF%26factor%3D1.25%26id%3De8d2c5777f5cf765&csi_page_type=watch&keywords=yumekui%2Cpv01&rec_key=F505D05C49C8D2FC-0B8DEB2F6DD9BDAF&rv.1.url=
http%3A%2F%2Fv23.lscache6.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXR1NPT19FSkNNN19LSVNH%26fexp%3D901305%252C900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1282341600%26key%3Dyt1%26signature%3D490EF6494A52DD17CDE0F60322D332DE8C330230.6AEF0FB9400F835CD70C93FADDF4EDE2ABDFA7BF%26factor%3D1.25%26id%3De8d2c5777f5cf765%7C%7Ctc.v23.cache6.c.youtube.com&rv.2.rating=5.0&rv.7.title=drawing+animation+SAND+CASTLE&cr=JP&rv.1.id=esci-6dsphg&rv.6.title=Jessika+-+4%2F4%E3%80%80Numazu+Wave&rv.4.length_seconds=292&record=1&rv.7.view_count=822&rv.5.view_count=51&length_seconds=71&enablejsapi=1&rec_title=Re%3A+%E5%A4%A2%E5%96%B0%E3%81%84%E3%83%A1%E3%83%AA%E3%83%BC+pv+19-08-2010&video_id=6NLFd39c92U&plid=AASOQ0w_GdW-nBjk&rv.5.rating=0.0&rv.0.author=wx9239&rv.4.url=
-------
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3D1C02F0D5FD6FA62895130671D34D6EE610BACBC6.1608C133406BE505FB72D22FA916E451A7B9B635%26factor%3D1.25%26id%3Daf7f1c30956cf3a9%2C5%7C
http%3A%2F%2Fv2.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3DC1EF1BDB6E7883761E2C14B43234A2AD3695B3FC.06724D69BDEF27F5FDE6C69E36E6078790F81EE0%26factor%3D1.25%26id%3Daf7f1c30956cf3a9&
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3D1C02F0D5FD6FA62895130671D34D6EE610BACBC6.1608C133406BE505FB72D22FA916E451A7B9B635%26factor%3D1.25%26id%3Daf7f1c30956cf3a9%7C%7Ctc.v6.cache8.c.youtube.com%2C5%7C
http%3A%2F%2Fv2.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3DC1EF1BDB6E7883761E2C14B43234A2AD3695B3FC.06724D69BDEF27F5FDE6C69E36E6078790F81EE0%26factor%3D1.25%26id%3Daf7f1c30956cf3a9%7C%7Ctc.v2.cache4.c.youtube.com&rv.2.rating=4.88461538462&
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3D1C02F0D5FD6FA62895130671D34D6EE610BACBC6.1608C133406BE505FB72D22FA916E451A7B9B635%26factor%3D1.25%26id%3Daf7f1c30956cf3a9%2C5%7C
http%3A%2F%2Fv2.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3DC1EF1BDB6E7883761E2C14B43234A2AD3695B3FC.06724D69BDEF27F5FDE6C69E36E6078790F81EE0%26factor%3D1.25%26id%3Daf7f1c30956cf3a9&
http%3A%2F%2Fv6.lscache8.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D34%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3D1C02F0D5FD6FA62895130671D34D6EE610BACBC6.1608C133406BE505FB72D22FA916E451A7B9B635%26factor%3D1.25%26id%3Daf7f1c30956cf3a9%7C%7Ctc.v6.cache8.c.youtube.com%2C5%7C
http%3A%2F%2Fv2.lscache4.c.youtube.com%2Fvideoplayback%3Fip%3D0.0.0.0%26sparams%3Did%252Cexpire%252Cip%252Cipbits%252Citag%252Calgorithm%252Cburst%252Cfactor%252Coc%253AU0dXSFZPT19FSkNNN19OSVND%26fexp%3D900031%252C900504%26algorithm%3Dthrottle-factor%26itag%3D5%26ipbits%3D0%26burst%3D40%26sver%3D3%26expire%3D1283641200%26key%3Dyt1%26signature%3DC1EF1BDB6E7883761E2C14B43234A2AD3695B3FC.06724D69BDEF27F5FDE6C69E36E6078790F81EE0%26factor%3D1.25%26id%3Daf7f1c30956cf3a9%7C%7Ctc.v2.cache4.c.youtube.com&rv.2.rating=4.88461538462

*/
		pat = Pattern.compile("(http%3A%2F%2[^.]+\\.lscache\\d+\\.c\\.youtube\\.com%2Fvideoplayback.+?%26id%3D([\\w\\-]+))");
//		pat = Pattern.compile("(http.+?\\.c\\.youtube\\.com.+?%26id%3D([\\w\\-]+)),");
		m = pat.matcher(str.replaceAll("\\r|\\n",""));
		if(m.find()){
			//movieurl = m.group(1);//URL擾
			id = m.group(2);//id擾
		}
		logWindow("[embed info] vid: " + vid + " / title: " + title + " / id: " + id + " /");
		if(title == null){
			logWindow("error: embed title error.");
			return;//s
		}
		if(id == null){
			logWindow("error: embed id error.");
			return;//s
		}
		//idƂ^Cgo^
		cacheid.put(id,vid+"<>"+fileEscape(title));
	}
	/** t@C̖OύX
	 * @param oldfile ύXÕt@C
	 * @param newfile ύX̃t@C
	 * @return ȂtrueAsȂfalse
	 */
	private boolean changeFileName(File oldfile,File newfile){
		//O̕ύXBԂl͉
		boolean status = false;
		if(newfile.exists()){
			//logInfo("file exists.");
			return status;
		}
		try{
			status = oldfile.renameTo(newfile);
		}catch(Exception e){
			//logInfo("file Exception."+e);
			status = false;
		}
		return status;
	}
	/** LbVꍇFileԂ
	 * @param id id
	 * @param rev trueȂtɂ
	 * @return CacheFile
	 */
	private File checkCacheFile(String id,boolean rev){
		//Ƃ肠ID݂̂Œׂ
		if(allCacheList.containsKey(id)){
			return allCacheList.get(id);
		}
		//Œׂ
		if(!rev){
			for(int i : flagFmtList){
				if(allCacheList.containsKey(id+NLFMT+i)){
					return allCacheList.get(id+NLFMT+i);
				}
			}
		}else{
			for(int i = flagFmtList.length - 1;i > 0;i--){
				if(allCacheList.containsKey(id+NLFMT+flagFmtList[i])){
					return allCacheList.get(id+NLFMT+flagFmtList[i]);
				}
			}
		}
		return null;
	}
	/** ꎞLbVꍇFileԂ
	 * @param id id
	 * @param rev trueȂtɂ
	 * @return CacheFile
	 */
	private File checkTmpCacheFile(String id,boolean rev){
		//Ƃ肠ID݂̂Œׂ
		if(allTmpCacheList.containsKey(id)){
			return allTmpCacheList.get(id);
		}
		//Œׂ
		if(!rev){
			for(int i : flagFmtList){
				if(allTmpCacheList.containsKey(id+NLFMT+i)){
					return allTmpCacheList.get(id+NLFMT+i);
				}
			}
		}else{
			for(int i = flagFmtList.length - 1;i > 0;i--){
				if(allTmpCacheList.containsKey(id+NLFMT+flagFmtList[i])){
					return allTmpCacheList.get(id+NLFMT+flagFmtList[i]);
				}
			}
		}
		return null;
	}
	//*******************************************************************************************************************
	// LbVǗ
	//*******************************************************************************************************************
	/** Content-Typet(I[o[[hp)
	 * @param sb tString
	 * @return tString
	 */
	private StringResource setResponseText(String sb) {
		return setResponseText(new StringBuilder().append(sb), "text/plain");
	}
	/** Content-Typet
	 * @param sb tString
	 * @param type Content-Type
	 * @return tString
	 */
	private StringResource setResponseText(StringBuilder sb,String type) {
		StringResource r = new StringResource(new String(sb));
		sb = null;
		r.setResponseHeader(HttpHeader.CONTENT_TYPE, type);
//		r.setHeaderEncode("UTF-8");
		r.addNoCacheResponseHeaders();
		return r;
	}
	/** LbVǗ̃C
	 * @param path path
	 * @param requestHeader HttpRequestHeader
	 * @return \[X
	 */
	private Resource tRequest(String path,HttpRequestHeader requestHeader) throws IOException {
		long st = System.currentTimeMillis();
		StringResource r = new StringResource("fail");
		if(path.equals("ex/")){
			r = makeFlvList2();
			if(System.currentTimeMillis() != st)
				logDebug("create time:ex: " + (System.currentTimeMillis() - st) + "msec");
		}else if(path.equals("")){
			r = makeFlvList();
			if(System.currentTimeMillis() != st)
				logDebug("create time:: " + (System.currentTimeMillis() - st) + "msec");
		}else if(path.equals("api")){
			r = makeAPIList();
		}else if(path.equals("log")){
			r = makeLog();
		}else if(path.equals("logclear")){
			LogBuffer = new StringBuilder();
			LogCount = 0;
			r = setResponseText(new StringBuilder().append("ok"),"text/plain");
		}else if(path.equals("flvlist")){
			r = setResponseText(new StringBuilder().append("# my cache\n" + makeList_Cache()),"text/plain");
		}else if(path.startsWith("ajax")){
			r = makeAjax(path,requestHeader);
			if(System.currentTimeMillis() != st)
				logDebug("create time:ajax: " + (System.currentTimeMillis() - st) + "msec");
		}else if(path.endsWith(".json")){
			r = makeJson(path);
		}else if(path.startsWith("yfetch?id=")){
			r = makeyFetch(path.substring(path.indexOf("=") + 1),requestHeader);
		}else if(path.equals("idlist")){
			r = makeIdList();
		}else if(path.equals("cachedl")){
			r = makeCacheDownloadingList();
		}else if(path.matches("[\\w\\-]+/movie")){
			String id = path.substring(0,path.lastIndexOf("/"));
			File ff = checkCacheFile(id,false);
			if(ff != null){
				String f = ff.getName();
				String ex = "";
				if(f.endsWith(".mp4")){//t@C̍Ōオmp4
					ex = "mp4";
				}else{
					ex = "flv";
				}
				return StringResource.getRedirect("http://www.nicovideo.jp/"+cachePage+"/"+id+"."+ex);
			}else{
				return setResponseText("NG noCache.");
			}
		}else if(path.matches("[\\w\\-]+/audio")){
			String id = path.substring(0,path.lastIndexOf("/"));
			File ff = checkCacheFile(id,false);
			if(ff != null){
				String f = ff.getName();
				String ex = "";
				if(f.endsWith(".mp4")){//t@C̍Ōオmp4
					ex = "m4a";
				}else{
					ex = "mp3";
				}
				return StringResource.getRedirect("http://www.nicovideo.jp/"+cachePage+"/"+id+"."+ex);
			}else{
				return setResponseText("NG noCache.");
			}
		}else if(path.matches("[\\w\\-]+\\.(?:mp4|flv)")){
			Pattern cs_movie = Pattern.compile("([\\w\\-]+)\\.(flv|mp4)");
			Matcher cs_m = cs_movie.matcher(path);
			if(cs_m.find()){
				File ff = checkCacheFile(cs_m.group(1),false);
				if(ff != null){
					Resource rr = Resource.get(Resource.Type.URL,ff.toURI().toString());
					rr.setResponseHeader("Cache-Control", "no-cache");
					String f = ff.getName();
					String ex;
					if(f.endsWith(".mp4")){//t@C̍Ōオmp4ȂcontentType
						rr.setResponseHeader(HttpHeader.CONTENT_TYPE, "video/mp4");
						ex = "mp4";
					}else{
						rr.setResponseHeader(HttpHeader.CONTENT_TYPE, "video/x-flv");
						ex = "flv";
					}
					if(ex.equals(cs_m.group(2))){
						logInfo("MoiveExtractor: "+f);
						return rr;
					}else{
						return setResponseText("NG extension error.");
					}
				}else{
					return setResponseText("NG noCache.");
				}
			}else{
				return setResponseText("NG");
			}
		}else if(path.matches("[\\w\\-]+\\.(?:mp3|m4a)")){
			Pattern cs_movie = Pattern.compile("([\\w\\-]+)\\.(mp3|m4a)");
			Matcher cs_m = cs_movie.matcher(path);
			if(cs_m.find()){
				File ff = checkCacheFile(cs_m.group(1),false);
				if(ff != null){
					String item[] = getCacheFileInfo(ff);
					String ex;
					if(item[4].endsWith(".mp4")){//t@C̍Ōオmp4
						ex = "m4a";
					}else{
						ex = "mp3";
					}
					if(ex.equals(cs_m.group(2))){
						if(ex.equals("m4a")){
							logInfo("AudioExtractor: "+item[1]+" "+item[3]+"."+ex);
							return mp4box(item[1],ff.getAbsolutePath(),item[3],requestHeader);
						}else{
							return setResponseText("NG flv.");
						}
					}else{
						return setResponseText("NG extension error.");
					}
				}else{
					return setResponseText("NG noCache.");
				}
			}else{
				return setResponseText("NG");
			}
		}else{
			r = setResponseText(new StringBuilder().append("none"),"text/plain");
		}
		return r;
	}
	/** ExtensionfetchB
	 * @param vid vid
	 * @param requestHeader HttpRequestHeader
	 * @return \[X
	 */
	private StringResource makeyFetch(String vid,HttpRequestHeader requestHeader){
		StringBuilder sb = new StringBuilder();
		String title = null;
		String curl = null;
		String id = null;
		String fmt = "";
		String fmtid = "";
		String str = getHttpRespons("http://www.youtube.com/watch?v="+vid + "&fmt=22",requestHeader,false);
		Pattern pat =  Pattern.compile("<title>\\s*\\S+\\s+\\S\\s+(.+)\\s+</title>",Pattern.DOTALL);
		Matcher m = pat.matcher(str.replaceAll("\\r|\\n",""));
		if(m.find()){
			title = m.group(1);//^Cg擾
		}
		pat =  Pattern.compile("\"fmt_list\"\\s*:\\s*\"([^\"]+)\"");
		m = pat.matcher(str);
		if(m.find()){
			fmt = m.group(1);//̓̉𑜓xꗗ擾
			fmtid = fmt.substring(0,fmt.indexOf("/")).replaceAll("\\\\","");
		}
		pat = Pattern.compile(fmtid+"\\|(http:(?:\\\\)?/(?:\\\\)?/[^/]+\\.c\\.youtube\\.com(?:\\\\)?/videoplayback[^,]+?&id=([\\w\\-]+))");
		m = pat.matcher(str);
		while(m.find()){//ŌɃ}b`urlg
			curl = m.group(1).replaceAll("\\\\","");//URL擾
			id = m.group(2);//id擾
		}
		//Op
		logWindow("yfetchwatch: " + vid + " / " + id + " / " + title + " / f:" + fmtid + " / (" + fmt + ")");
		//ǂꂩȂ玸s
		if(title == null || curl == null || id == null){
			sb.append("NG\n");
			return setResponseText(sb,"text/plain");
		}else{
		}
		//LbVȂJnȂ
		File ff = checkCacheFile(vid,false);
		if(ff != null && cache_downloading.containsKey(vid+NLFMT+fmtid)){
			sb.append("NG\n");
			return setResponseText(sb,"text/plain");
		}
		sb.append("OK\n");
		//idƂ^Cgo^
		cacheid.put(id,vid+"<>"+fileEscape(title));
		//requestHeaderɓurlݒ
		logWindow("yfetchwatch: URL: " + curl + "");
		requestHeader.setURI(curl);
		try{
			//ʃXbhŃLbV
			YouTubeCacheExtension yc = new YouTubeCacheExtension(requestHeader,vid,title,fmtid);
			yc.thread = new Thread(yc);
			yc.thread.start();
		}catch(IOException e){
			sb.append(e + "\n");
		}catch(Exception e){
			sb.append(e + "\n");
		}
		return setResponseText(sb,"text/plain");
	}
	/** idlisto
	 * @return \[X
	 */
	private StringResource makeIdList(){
		StringBuilder sb = new StringBuilder();
		String all1 = new String(makeList_Cache());
		sb.append("#start\n");
		for(String id : all1.split("\\s+")){
			if(id.length() > 15){
				sb.append(id.replaceFirst(NLFMT+"\\d+\\.(?:flv|mp4)","")+"\n");
			}else{
				sb.append(id.replaceFirst("\\.(?:flv|mp4)","")+"\n");
			}
		}
		logDebug("File Write IdFile");
		fileWriter(new String(sb));//Listpɏo
		return setResponseText(sb,"text/plain");
	}
	/** O`
	 * @return \[X
	 */
	private StringResource makeLog(){
		StringBuilder sb = new StringBuilder();
		//sb.append("Log\n");
		sb.append(LogBuffer);
		return setResponseText(sb,"text/plain");
	}
	/** gAPI`
	 * @return \[X
	 */
	private StringResource makeAPIList(){
		StringBuilder sb = new StringBuilder();
		sb.append("api\n");
		sb.append("*******************\n");
		sb.append("/log\n");
		sb.append("-----ڍׂȃO\n");
		sb.append("/idlist\n");
		sb.append("-----$LST()pɃt@CXgt@Cɕۑ\n");
		sb.append("/cachedl\n");
		sb.append("-----Dl̃t@C̏  ۑĂID̈ꗗ\n");
		sb.append("/ajax\n");
		sb.append("-----SẴLbV̏ڍ׏\n");
		sb.append("/ajax_status?<id>\n");
		sb.append("-----DLȂ牽%DL\n");
		sb.append("-----dd.d%\n");
		sb.append("-----NG\n");
		sb.append("/ajax_info?<id>\n");
		sb.append("-----OK,<Sꎞ>,<gq>,<t@CTCY>,<dlȂŏITCYBς݂Ȃ0>,<fmt>,t@C^Cg\n");
		sb.append("-----NG\n");
		sb.append("/ajax_rm?<id>\n");
		sb.append("-----OK / NG\n");
		sb.append("/ajax_title?<id>\n");
		sb.append("-----OK / NG\n");
		sb.append("/ajax_title?<id>\n");
		sb.append("-----OK <newName> / NG\n");
		sb.append("/ajax_title?<id>&<newName>\n");
		sb.append("-----OK <newName> / NG\n");
		sb.append("/ajax_move?<id>&<forder>\n");
		sb.append("-----OK / NG\n");
		sb.append("/ajax_topmove?<id>&<forder>\n");
		sb.append("-----OK / NG\n");
		sb.append("/yfetch?id=<id>\n");
		sb.append("-----OK / NG\n");
		sb.append("/<id>/movie\n");
		sb.append("-----LbVĂuEUɓn\n");
		sb.append("/<id>/audio\n");
		sb.append("-----LbVĂ特yf[^̂݃uEUɓn\n");
		sb.append("-----MP4(m4a)̂ݑΉ\n");
		sb.append("*******************\n");
		sb.append("/cachelist.json\n");
		sb.append("/templist.json\n");
		sb.append("/dirlist.json\n");
		sb.append("/flvlist.json\n");
		sb.append("*******************\n");
		return setResponseText(sb,"text/plain");
	}
	/** flvXg𐶐
	 * @return \[X
	 */
	private StringResource makeFlvList2(){
		//Ǘy[WɃANZX̏ꍇ͖ST邱Ƃɂ
		initYouTubeCache(true);
		//
		String templateFilename = System.getProperty("ytc_TemplateFile2");
		if (!templateFilename.equals("")) {//Ȃɂw肵ĂȂ
			File templateFile = new File(new File("."), templateFilename);
			if(templateFile.exists()){//t@Cꍇ̂ݏ
				return makeCacheTemplateFile(templateFile);
			}else{
				logInfo("templateFile not exists");
				return makeFlvList();
			}
		}
		return makeFlvList();
	}
	/** cachedlp
	 * @return \[X
	 */
	private StringResource makeCacheDownloadingList(){
		StringBuilder sb = new StringBuilder();
		long scd = cache_downloading.size();
		long sci = cacheid.size();
		int count = 0;
		sb.append("{\n");
		if(scd > 0){
			for (Map.Entry<String,Long> e : cache_downloading.entrySet()) {
				String id = e.getKey();
				File ft = checkTmpCacheFile(id,false);
				sb.append(id + " / ");
				if(ft != null){
					sb.append(ft.getName());
				}
				count++;
				if(count < scd){
					sb.append(",\n");
				}
			}
		}
		sb.append("\n}\n");
		count = 0;
		sb.append("{\n");
		if(sci > 0){
			for (Map.Entry<String,String> e : cacheid.entrySet()) {
				sb.append(e.getKey() + "<>" + e.getValue());
				count++;
				if(count < sci){
					sb.append(",\n");
				}
			}
		}
		sb.append("\n}\n");
		return setResponseText(new String(sb));
	}
	/** flvlist
	 * @return \[X
	 */
	private StringResource makeFlvList(){
		//Ǘy[WɃANZX̏ꍇ͖ST邱Ƃɂ
		initYouTubeCache(true);
		//
		String templateFilename = System.getProperty("ytc_TemplateFile");
		if (!templateFilename.equals("")) {//Ȃɂw肵ĂȂ
			File templateFile = new File(new File("."), templateFilename);
			if(templateFile.exists()){//t@Cꍇ̂ݏ
				return makeCacheTemplateFile(templateFile);
			}else{
				logInfo("templateFile not exists");
			}
		}
		StringBuilder sb = new StringBuilder();
		sb.append("<html>\n");
		sb.append("<head>\n");
		sb.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
		sb.append("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n");
		sb.append("<meta http-equiv=\"Cache-Control\" content=\"no-cache\">\n");
		sb.append("<script type=\"text/javascript\" src=\"http://res.nimg.jp/js/lib/prototype.js\"></script>");
		sb.append("<script type=\"text/javascript\" src=\"/local/youtubecache/ytcjs.js\"></script>");
		sb.append("<title>LocalYouTubeFlv</title>\n");
		sb.append("</head>\n");
		sb.append("<body>\n");
		Map<String, File> caches = allTmpCacheList;
		sb.append("<a href=\"http://www.youtube.com/\">youtbe</a> / <br>");
//		sb.append(LastModifiedCacheForder + " / " + (convertUnixtime(LastModifiedCacheForder/1000)) + "<br>\n");
		sb.append("YouTube tmp cache list/"+caches.size()+"<br>\n");
		if (caches.size() != 0) {
			File cFile = null;
			Long flen = 0l;
			Long mlen = 0l;
			double sizeratio = 0l;
			sb.append("<table border=\"1\" cellspacing=\"0\" cellpadding=\"2\">\n");
			sb.append("<tr><th></th><!--<th>Info</th>--><th>link</th><th>id</th><th>fmt</th><th>title</th><th>ex</th><th>flag</th>");
			sb.append("<th>nowsize</th><th>maxsize</th><th>nowratio</th><!--<th>lastmod</th>--></tr>\n");
			for (String id: caches.keySet()){
				cFile = caches.get(id);
				String item[] = getCacheFileInfo(cFile);
				flen = cFile.length();
				mlen = cache_downloading.containsKey(item[1]) ? cache_downloading.get(item[1]):0;
				sizeratio =  (((double) flen / (double)mlen));
				sb.append("<tr>");
				sb.append("<td><a href=\"javascript:void(0)\" onclick=\"ytcutiljs(this,'rm','"+item[1]+"')\"></a></td>");
//				sb.append("<td><a href=\"http://www.nicovideo.jp/cache_youtube/ajax_info?" + item[1] + "\">Info</a></td>");
				sb.append("<td><a href=\"http://www.youtube.com/watch?v=" + item[1] + "\">" + item[1] + "</a></td>");
				sb.append("<td>" + item[1] + "</td>");
				sb.append("<td>" + (item[2].equals("")?"<br>":item[2]) + "</td>");
				sb.append("<td>" + item[3] + "</td>");
				sb.append("<td>" + item[4] + "</td>");
				sb.append("<td>" + cache_downloading.containsKey(item[1]) + "</td>");
				sb.append("<td>" + String.format("%,d KByte",flen/1024) + "</td>");
				sb.append("<td>" + String.format("%,d KByte",mlen/1024) + "</td>");
				sb.append("<td>" + ((mlen != 0)?String.format("%.4f",sizeratio*100)+"%":"????%") + "</td>");
//				sb.append("<td>" + (convertUnixtime(cFile.lastModified()/1000)) + "</td>");
//				sb.append("<td>" + cFile.getAbsolutePath() + "</td>");
				sb.append("</tr>\n");
			}
			sb.append("</table>\n");
		}
		caches = allCacheList;
		sb.append("YouTube cache list/"+caches.size()+"<br>\n");
		if (caches.size() != 0) {
			sb.append("<table border=\"1\" cellspacing=\"0\" cellpadding=\"2\">\n");
			sb.append("<tr><th>folder</th>");
			for(String item:flagManagerLinks){
				if(item.equals("")){
					sb.append("<th></th>");
				}else if(item.equals("")){
					sb.append("<th></th>");
				}else if(item.equals("")){
					sb.append("<th></th>");
				}else if(item.equals("")){
					sb.append("<th></th>");
				}
			}
			sb.append("<th>link</th><th>id</th><th>fmt</th>");
			sb.append("<th>title</th><th>ex</th><!--<th>len</th><th>lastmod</th>--></tr>\n");
			TreeSet<String> trlist = new TreeSet<String>();
			StringBuilder alist = null;
			for (String id: caches.keySet()){
				alist = new StringBuilder();
				String item[] = getCacheFileInfo(caches.get(id));
				//0 folder
				//1 id
				//2 fmt
				//3 title
				//4 ext
				alist.append("<tr>");
				alist.append("<td><!--" + item[0] + "/" + item[3] + "-->" + item[0] + "<br></td>");
				for(String links:flagManagerLinks){
					if(links.equals("")){
						alist.append("<td><a href=\"javascript:void(0)\" onclick=\"ytcutiljs(this,'rm','"+item[1]+"')\"></a></td>");
					}else if(links.equals("")){
						alist.append("<td><a href=\"javascript:void(0)\" onclick=\"ytcutiljs(this,'mv','"+item[1]+"')\"></a></td>");
					}else if(links.equals("")){
						if(item[4].equals(".mp4")){
							alist.append("<td><a href=\"./" + item[1] + "/audio\"></a></td>");
						}else{
							alist.append("<td><br></td>");
						}
					}else if(links.equals("")){
						alist.append("<td><a href=\"./" + item[1] + "/movie\"></a></td>");
					}
				}
//				alist.append("<td><a href=\"http://www.nicovideo.jp/cache_youtube/ajax_info?" + item[1] + "\">I</a></td>");
//				alist.append("<td><a href=\"http://www.youtube.com/watch?v=" + item[1] + "\" "+
//					"onmouseout=\"hideThum(this)\" onmouseover=\"viewThum(this,'"+item[1]+"')\">" + item[1] + "</a></td>");
				alist.append("<td><a href=\"http://www.youtube.com/watch?v=" + item[1] + "\">" + item[1] + "</a></td>");
				alist.append("<td>" + item[1] + "</td>");
				alist.append("<td>" + (item[2].equals("")?"<br>":item[2]) + "</td>");
				alist.append("<td>" + item[3] + "</td>");
				alist.append("<td>" + item[4] + "</td>");
//				alist.append("<td>" + String.format("%,d KByte",cFile.length()/1024) + "</td>");
//				alist.append("<td>" + (convertUnixtime(cFile.lastModified()/1000)) + "</td>");
				//alist.append("<td> + cFile.getAbsolutePath() + "</td>");
				alist.append("</tr>\n");
				trlist.add(alist.toString());
			}
			for(String line : trlist){
				sb.append(line);
			}
			trlist = null;//GCpɊJ
			sb.append("</table>\n");
		}
		sb.append("<hr>\n");
/*		int count = 0;
		sb.append("YouTube cache folder list/"+allFolderList.size()+"<br>\n");
		if(allFolderList.size() > 0){
			sb.append("{<br>\n");
			for(String item:allFolderList){
				sb.append(cacheDir + FS + item + FS);
				count++;
				if(count < allFolderList.size()){
					sb.append(",<br>\n");
				}
			}
			sb.append("<br>\n}<br>\n");
		}
		count = 0;//0ɖ߂
		sb.append("downloading file./"+cache_downloading.size()+"<br>\n");
		if(cache_downloading.size() > 0){
			sb.append("{<br>\n");
			for (Map.Entry<String,Long> e : cache_downloading.entrySet()) {
				sb.append(e.getKey() + "");
				count++;
				if(count < cache_downloading.size()){
					sb.append(",");
				}
			}
			sb.append("<br>}<br>\n");
		}
		count = 0;//0ɖ߂
		sb.append("cacheid./"+cacheid.size()+"<br>\n");
		if(cacheid.size() > 0){
			sb.append("{<br>\n");
			for (Map.Entry<String,String> e : cacheid.entrySet()) {
				sb.append(e.getKey() + " / " + e.getValue());
				count++;
				if(count < cacheid.size()){
					sb.append(",<br>");
				}
			}
			sb.append("<br>}<br>\n");
		}
*/
		sb.append("</body>\n");
		sb.append("</html>\n");
		//svȂ̂͏Ă
		if(cacheid.size() > 50 && allTmpCacheList.size() == 0 && cache_downloading.size() == 0){
			//cacheid 50ȏ゠  tmpt@CȂ  _E[h̃t@CȂ
			cacheid.clear();
		}
//		logDebug(cacheid.toString());
		caches = null;//J
		return setResponseText(sb, "text/html");
	}
	/** t@Cw肵Ãt@C̒gԂ
	 * @param filename ev[g̃t@C
	 * @return ev[g̒g
	 */
	private StringResource makeCacheTemplateFile(File filename){
		//logInfo(code);
		StringBuilder sb = new StringBuilder();
		// R[h`FbN
		String charCode = checkCharCode(filename);
		BufferedReader br = null;
		try {
			if (charCode == null) {
				br = new BufferedReader(new FileReader(filename));
			} else {
				br = new BufferedReader(new InputStreamReader(new FileInputStream(filename), charCode) );
				if (charCode.equals("UTF-8")) {
					br.mark(1);
					int bom = br.read();
					if (bom != 0xFEFF) br.reset();
				}
			}
			String read;
			while ((read = br.readLine()) != null) {
				sb.append(read + "\n");
			}
		}catch(Exception e){
			logDebug("template Exception. /"+e);
		}
		return setResponseText(sb, "text/html");
	}
	/** ajax`
	 * @return \[X
	 */
	private StringResource makeAjax(String path,HttpRequestHeader requestHeader){
		StringBuilder sb = new StringBuilder();
		String npath = convertURLDecoder(path);
		if(path != null){
			path = npath;//fR[hsȂ猳ɖ߂
		}
		if(path.equals("ajax")){
			initYouTubeCache(true);//LbVT
			sb.append(makeAjaxCacheList());
		}else if(path.startsWith("ajax_info?")){
			sb.append(makeAjaxCacheInfo(path.substring(path.indexOf("?")+1)));
		}else if(path.startsWith("ajax_rm?")){
			sb.append(makeAjaxCacheRemove(path.substring(path.indexOf("?")+1)));
		}else if(path.startsWith("ajax_title?")){
			sb.append(makeAjaxCacheTitle(path.substring(path.indexOf("?")+1),path.contains("&"),requestHeader));
		}else if(path.startsWith("ajax_move?")){
			sb.append(moveCache(path.substring(path.indexOf("?")+1),false));
		}else if(path.startsWith("ajax_topmove?")){
			sb.append(moveCache(path.substring(path.indexOf("?")+1),true));
		}else if(path.startsWith("ajax_status?")){
			sb.append(makeAjaxCacheStatus(path.substring(path.indexOf("?")+1)));
		}else{
			sb.append("fail\n");
		}
		return setResponseText(sb, "text/plain");
	}
	/** jsonʕ`
	 * @return \[X
	 */
	private StringResource makeJson(String path){
		StringBuilder sb = new StringBuilder();
		if(path.equals("cachelist.json")) {
			initYouTubeCache(true);//LbVT
			sb.append("{\n"+makeJson_Cache()+"\n}\n");
		}else if(path.equals("templist.json")){
			sb.append("{\n"+makeJson_tmpCache()+"\n}\n");
		}else if(path.equals("dirlist.json")){
			sb.append("["+makeJson_folder()+"]\n");
		}else if(path.equals("flvlist.json")){
			initYouTubeCache(true);//LbVT
			sb.append("{\n");
			sb.append("\"dirList\":["+makeJson_folder()+"],\n");
			sb.append("\"tempList\":{\n"+makeJson_tmpCache()+"\n},\n");
			sb.append("\"cacheList\":{\n"+makeJson_Cache()+"\n}\n");
			sb.append("}\n");
		}else{
			sb.append("fail\n");
		}
		return setResponseText(sb, "text/plain");
	}
	/** t@Cړ
	 * @param path t@CƃtH_
	 * @param flag top݂̂Ŝ
	 * @return ȂtrueAsȂfalse
	 */
	private StringBuilder moveCache(String path,boolean flag){
		StringBuilder sb = new StringBuilder();
		String[] t = path.split("&", 2);
		if(t.length == 1){//tH_Ȃ
			logDebug("[moveAPI] error: not folder name error.");
			sb.append("NG\n");
			return sb;
		}
		if(!allFolderList.contains(t[1]) && !t[1].equals("")){
			//tH_Ȃ  Ȃɂw肵Ăꍇ Ȃ
			logDebug("[moveAPI] error: not folder error.");
			sb.append("NG\n");
			return sb;
		}
		File ff = checkCacheFile(t[0],true);//𑜓x̂Ttrue
		if(ff != null){
			String forder = ff.getParent().replaceFirst(cacheDirString+"\\\\","").replaceFirst(cacheDirString,"");
			if(!forder.equals("") && flag){
				//LbVtopȊOɂ+topmovêƂ
				logDebug("[moveAPI] error: topCache not move.");
				sb.append("NG\n");
				return sb;
			}
			String movef = ((t[1].equals(""))?"":t[1]+FS);
			File n = new File(cacheDir,movef+FS+ff.getName());
			//logInfo(n.getAbsolutePath());
			//logInfo(ff.getAbsolutePath());
			if(n.getAbsolutePath().equals(ff.getAbsolutePath())){
				logDebug("[moveAPI] error: The same destination.");//
				sb.append("NG\n");
				return sb;
			}
			if(!n.exists()){//t@C݂ȂȂ
				if(changeFileName(ff,n)){
					logInfo("youtube cache move." + ff.getName());
					sb.append("OK\n");
				}else{
					logDebug("[moveAPI] error: cache not move.");
					//ύXs
					sb.append("NG\n");
				}
			}else{
				//ꏊɈړ̉\
				//ɂ͗Ȃ͂
				logDebug("[moveAPI] error: cacheFile exists.");
				sb.append("NG\n");
			}
		}else{
			sb.append("NG\n");
		}
		return sb;
	}
	/** ajax_infop`
	 * @param id id
	 * @return 
	 */
	private StringBuilder makeAjaxCacheInfo(String id){
		StringBuilder sb = new StringBuilder();
		File ff = checkCacheFile(id,false);
		File ft = checkTmpCacheFile(id,false);
		if(ff != null){
			String item[] = getCacheFileInfo(ff);
			sb.append("OK,,"+item[4]+","+ff.length()+",0,"+item[2]+","+item[3]+"\n");
		}else if(ft != null){
			String item[] = getCacheFileInfo(ft);
			sb.append("OK,tmp,"+item[4]+","+ft.length()+","+(cache_downloading.containsKey(id) ? cache_downloading.get(id):"-1")+","+item[2]+","+item[3]+"\n");
		}else{
			sb.append("NG\n");
		}
		return sb;
	}
	/** ajax_rmp`
	 * @param id id
	 * @return 
	 */
	private StringBuilder makeAjaxCacheRemove(String id){
		StringBuilder sb = new StringBuilder();
		File ff = checkCacheFile(id,false);
		File ft = checkTmpCacheFile(id,false);
		if(ff != null){
			if(ff.delete()){
				sb.append("OK\n");
				logMulti("Remove YouTube Cache: "+id);
			}else{
				logDebug("[rmAPI] error: deleate false.");
				sb.append("NG\n");
			}
		}else if(ft != null){
			if(ft.delete()){
				sb.append("OK\n");
				logMulti("Remove YouTube Temporary Cache: "+id);
			}else{
				logDebug("[rmAPI] error: deleate false.");
				sb.append("NG\n");
			}
		}else{
			logDebug("[rmAPI] error: not file.");
			sb.append("NG\n");
		}
		return sb;
	}
	/** ajax_title p`
	 * @param id id
	 * @param rename newname flag
	 * @return 
	 */
	private StringBuilder makeAjaxCacheTitle(String id,boolean rename,HttpRequestHeader requestHeader){
		StringBuilder sb = new StringBuilder();
		boolean status = false;
		String title = "";
		String pos = "";
		String oname = "";
		String fol = "";
		if(rename){
			String[] sp = id.split("&",2);
			id = sp[0];
			title = sp[1];
		}
		File n = checkCacheFile(id,false);
		File nt = checkTmpCacheFile(id,false);
		if(n != null){
			status = true;
		}else if(nt != null){
			n = nt;
			nt = null;
			status = true;
		}else{
			logDebug("[titleAPI] error: not file.");
			sb.append("NG\n");
			return sb;
		}
		oname = n.getName();
		String idf = "";
		int fi = oname.indexOf(NLPOS);
		if(fi > 0){
			String id2 = oname.substring(0,fi);
			int fif = id2.lastIndexOf(NLFMT);
			if(fif > 0 && id2.length() > 11){
				idf = id2.substring(fif+1);
			}
		}
		if(idf != null && !idf.equals("")){
			idf = NLFMT + idf;
		}
		if(status && !rename){
			title = id + idf + NLPOS + fileEscape(getYouTubeTitle(id,requestHeader));
			pos = oname.substring(oname.lastIndexOf("."));
			fol = n.getParent().replaceFirst(cacheDirString+"\\\\","").replaceFirst(cacheDirString,"");
			if(!fol.equals("")){
				fol += FS;
			}
			logMulti("YouTube Cache rename: " + title + pos);
			changeFileName(n,new File(cacheDir + FS + fol + title + pos));
			LastModifiedCacheForder = 1;//IɃtH_ēǂݍ݂
			sb.append("OK " + title + "\n");
		}else if(status && rename){
			title = id + idf + NLPOS + fileEscape(title);
			pos = oname.substring(oname.lastIndexOf("."));
			fol = n.getParent().replaceFirst(cacheDirString+"\\\\","").replaceFirst(cacheDirString,"");
			if(!fol.equals("")){
				fol += FS;
			}
			logMulti("YouTube Cache rename: " + title + pos);
			changeFileName(n,new File(cacheDir + FS + fol + title + pos));
			LastModifiedCacheForder = 1;//IɃtH_ēǂݍ݂
			sb.append("OK " + title + "\n");
		}else{
			//donot
		}
		return sb;
	}
	/** DL̓̃LbVp[Zg
	 * @param id id
	 * @return 
	 */
	private StringBuilder makeAjaxCacheStatus(String id){
		StringBuilder sb = new StringBuilder();
		File ft = checkTmpCacheFile(id,false);
		if(ft != null && cache_downloading.containsKey(id)){
			Long flen = ft.length();
			Long mlen = cache_downloading.get(id);
			double sizeratio =  (((double) flen / (double)mlen));
			if(mlen != 0){
				sb.append(String.format("%.1f",sizeratio*100)+"%");
			}else{
				sb.append("NG");
			}
		}else if(ft != null){
			sb.append("NG noDownload.");
		}else{
			sb.append("NG");
		}
		return sb;
	}
	/** json folderp
	 * @return 
	 */
	private StringBuilder makeJson_folder(){
		StringBuilder sb = new StringBuilder();
		sb.append("\"\"");
		for(String path : allFolderList){
			sb.append(", \""+path.replaceAll("\\\\","/")+"\"");
		}
		return sb;
	}
	/** json tmpcachep
	 * @return 
	 */
	private StringBuilder makeJson_tmpCache(){
		StringBuilder sb = new StringBuilder();
		Map<String, File> caches = allTmpCacheList;
		if (caches.size() != 0) {
			File cFile = null;
			int i = 0;
			for (String id: caches.keySet()){
				cFile = caches.get(id);
				String item[] = getCacheFileInfo(cFile);
				sb.append("\"" + item[1] + "\":[");
				sb.append("\"" + item[3] + "\", ");
				sb.append("\"" + item[0] + "\", ");
				sb.append("\"" + cache_downloading.containsKey(item[1]) + "\",");
				sb.append("" + cFile.length() + ",");
				sb.append("" + (cache_downloading.containsKey(item[1]) ? cache_downloading.get(item[1]):"-1") + ",");
				sb.append("" + cFile.lastModified()/1000 + "");
				sb.append("]");
				i++;
				if(i < caches.size()){
					sb.append(",\n");
				}
			}
		}
		caches = null;//J
		return sb;
	}
	/** json cachep
	 * @return 
	 */
	private StringBuilder makeJson_Cache(){
		StringBuilder sb = new StringBuilder();
		Map<String, File> caches = allCacheList;
		if (caches.size() != 0) {
			File cFile = null;
			int i = 0;
			for (String id: caches.keySet()){
				cFile = caches.get(id);
				String item[] = getCacheFileInfo(cFile);
				if(cFile == null || item == null) continue;
				sb.append("\"" + item[1] + "\":[");
				sb.append("\"" + item[3] + "\", ");
				sb.append("\"" + item[0] + "\", ");
				sb.append("" + cFile.length() + ",");
				sb.append("" + cFile.lastModified()/1000 + "");
				sb.append("]");
				i++;
				if(i < caches.size()){
					sb.append(",\n");
				}
			}
		}
		caches = null;//J
		return sb;
	}
	/** allcachep
	 * @return 
	 */
	private StringBuilder makeList_Cache(){
		StringBuilder sb = new StringBuilder();
		Map<String, File> caches = allCacheList;
		if (caches.size() != 0) {
			File cFile = null;
			String fn = null;
			int i = 0;
			for (String id: caches.keySet()){
				cFile = caches.get(id);
				fn = cFile.getName();
				sb.append(id + "." + fn.substring(fn.lastIndexOf(".")+1) + "");
				i++;
				if(i < caches.size()){
					sb.append(" ");
				}
			}
		}
		caches = null;//J
		return sb;
	}
	/** alltmpcachep
	 * @return 
	 */
	private StringBuilder makeList_CacheTmp(){
		StringBuilder sb = new StringBuilder();
		Map<String, File> caches = allTmpCacheList;
		if (caches.size() != 0) {
			File cFile = null;
			String fn = null;
			int i = 0;
			for (String id: caches.keySet()){
				cFile = caches.get(id);
				fn = cFile.getName();
				sb.append(id + "." + fn.substring(fn.lastIndexOf(".")+1) + "");
				i++;
				if(i < caches.size()){
					sb.append(" ");
				}
			}
		}
		caches = null;//J
		return sb;
	}
	/** ajaxp
	 * @return 
	 */
	private StringBuilder makeAjaxCacheList(){
		StringBuilder sb = new StringBuilder();
		sb.append("version = \"" + EXTENSION_TITLE1 + " " + EXTENSION_VERSION + "\";\n");
		sb.append("dirList = ["+makeJson_folder()+"]\n");
		sb.append("tempList = {\n"+makeJson_tmpCache()+"\n};\n");
		sb.append("cacheList = {\n"+makeJson_Cache()+"\n};\n");
		sb.append("forLocalFlv = \"" + makeList_Cache() + "\";\n");
		return sb;
	}
	/** LbṼ^Cgyoutube擾Đݒ
	 * @param id id
	 * @param requestHeader HttpRequestHeader
	 * @return ^Cg
	 */
	private String getYouTubeTitle(String id,HttpRequestHeader requestHeader){
		String str = getHttpRespons("http://www.youtube.com/watch?v="+id,requestHeader,false);
		Pattern pat =  Pattern.compile("<title>\\s*\\S+\\s+\\S\\s+(.+)\\s+</title>",Pattern.DOTALL);
		Matcher m = pat.matcher(str.replaceAll("\\r|\\n",""));
		String title = "unknown";
		if(m.find()){
			title = m.group(1);
		}
		return title;
	}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
	/** LbVT */
	private void initYouTubeCache(boolean flag){
		if(flag){//STtO
			LastModifiedCacheForder=0;
		}
		long lastmod = cacheDir.lastModified();
		//logDebug(lastmod+"/"+LastModifiedCacheForder);
		if(lastmod == 0){
			//񂩃tH_Ȃ
			cacheDir.mkdir();//LbVtH_쐬
		}else if(lastmod <= LastModifiedCacheForder){
			//XVȂ
			return;
		}else{//XV
		}
		LastModifiedCacheForder = lastmod;
		//logWindow("Reload youtube Cache Folder.");
		//logInfo("Reload youtube Cache Folder.");
		//logDebug("Reload youtube Cache Folder.");
		//
		allTmpCacheList.clear();
		allCacheList.clear();
		allFolderList.clear();
		//
		if (cacheDir.isDirectory()) {
			String[] list = cacheDir.list();
			for(String id:list){
				if(id.endsWith(".mp4") || id.endsWith(".flv")){
					if(id.startsWith(NLTMP)){
						allTmpCacheList.put(id.substring(NLTMP.length(),(id.indexOf(NLPOS) > 0)?id.indexOf(NLPOS):id.indexOf(".")),new File(cacheDir + FS + id));
					}else{
						allCacheList.put(id.substring(0,(id.indexOf(NLPOS) > 0)?id.indexOf(NLPOS):id.indexOf(".")),new File(cacheDir + FS + id));
					}
				}else{
					//tH_ł\
					getYouTubeCacheFileFolder(id);
				}
			}
		}
	}
	/** ċNp̃tH_T
	 * @param f tH_
	 */
	private void getYouTubeCacheFileFolder(String f){
		File file = new File(cacheDir + FS + f);
		ArrayList<String> flist = new ArrayList<String>();
		if (file.isDirectory()) {
			allFolderList.add(f);
			String[] list = file.list();
			for(String id:list){
				if(id.endsWith(".mp4") || id.endsWith(".flv")){
					if(id.startsWith(NLTMP)){
						//allTmpCacheList.put(id.substring(NLTMP.length(),(id.indexOf(NLPOS) > 0)?id.indexOf(NLPOS):id.indexOf(".")),new File(cacheDir + FS + f + FS + id));
					}else{
						allCacheList.put(id.substring(0,(id.indexOf(NLPOS) > 0)?id.indexOf(NLPOS):id.indexOf(".")),new File(cacheDir + FS + f + FS + id));
					}
				}else{
					getYouTubeCacheFileFolder(f + FS + id);
				}
			}
		}else{
			//tH_ȂB
		}
	}
	/** file̖O𕪊ĕԂ
	 * @param ff file
	 * @return zB 0 folder 1 id 2 fmt 3 title 4 ext
	 */
	private String[] getCacheFileInfo(File ff){
		if(ff == null){
			return new String[]{"","","",""};
		}
		String fn = ff.getName().replaceFirst(NLTMP,"");
		String ids[] = fn.split("#",2);
		String id = "";
		String fmt = "";
		String title = "";
		String folder = ff.getParent().replaceFirst(cacheDirString+"\\\\","").replaceFirst(cacheDirString,"").replaceAll("\\\\","/");
		String posifix = fn.substring(fn.lastIndexOf("."));
		boolean fmtf = true;
		if(ids.length == 2){
			id = ids[0];
		}else{
			id = ids[0];
		}
		id = id.replaceFirst(posifix,"");
		if(id.length() > 16){//id̂
			int fs = id.lastIndexOf(NLFMT);
//			int fs2 = id.lastIndexOf(".");
			if(fs > 0){//NLFMTB
				fmt = id.substring(fs+1);//id̂Ȃfmt؂
				if(fmt.length() > 2){//fmt2ȏB
					int fms = fmt.lastIndexOf(".");
					if(fms > 0){//fmt̒Ɋgq
						fmt = fmt.substring(0,fms);//gq܂łƂ
					}
				}
				id  = id.substring(0,fs);
			}
		}else if(id.length() > 11){//vid
			int fs = id.lastIndexOf(NLFMT);
			if(fs > 0){//NLFMT
				fmt = id.substring(fs+1);//id̂Ȃfmt؂
				id  = id.substring(0,fs);//id̂Ȃfmt؂
			}
		}else{//fmtȂ
			fmtf = false;
			//donot
		}
		if (fn.length() > id.length() + posifix.length() + ((fmtf)?fmt.length()+NLFMT.length():0)){
			title = fn.substring(id.length() + NLPOS.length() + ((!fmt.equals(""))?fmt.length()+NLFMT.length():0), fn.length() - posifix.length());
		}else{
			title = "unknown";
		}
		return new String[]{folder,id,fmt,title,posifix};
	}
	//*******************************************************************************************************************
	// TransferListener
	//*******************************************************************************************************************
	/** W[̃wb_p^[ */
	private static final Pattern CONTENT_RANGE_VALUE_PATTERN = Pattern.compile("bytes (\\d+)-(\\d+)/(\\d+)");
	/** t@C̏ݗp */
	private FileChannel cache_fileChannel = null;
	/** id */
	private String cache_id = "";
	/** ̃^Cg */
	private String cache_title = "";
	/** fmt */
	private String cache_fmt = "";
	/** Oɕ\pString */
	private String cache_logname = "";
	/** ANZXHttpRequestHeader */
	private HttpRequestHeader cache_requestHeader = null;
	/** G[true */
	private boolean cache_errorStatus = false;
	/** W[łԂȂtrue */
	private boolean cache_partial = false;
	/** d_E[hԂȂtrue */
	private boolean cache_dupconnect = false;
	/** ̃TCY */
	private long cache_contentLength = 0;
	/** ̈ꎞTCY */
	private long cache_tmpSize = 0;
	/** Resource */
	private Resource cache_resource = null;
	/** File */
	private File cache_file = null;
	/** InputStream */
	private InputStream cache_inputStream = null;
	/** ̊gq */
	private String cache_posifix = "";
	/** OutputStream */
	private FileOutputStream cache_fileOutputStream = null;
	//*******************************************************************************************************************
	/** RXgN^2
	 * @param requestHeader HttpRequestHeader
	 * @param id id
	 * @param title title
	 * @throws IOException
	 */
	public YouTubeCacheExtension(HttpRequestHeader requestHeader,String id,String title,String fmt) throws IOException {
		this.cache_id = id;
		this.cache_fmt = ((fmt == null || fmt.equals(""))?"":NLFMT) + fmt;
		this.cache_title = ((title == null || title.equals(""))?"":NLPOS) + title;
		this.cache_requestHeader = requestHeader;
		this.cache_fileChannel = null;
		this.cache_errorStatus = false;
		this.cache_partial = false;
		this.cache_dupconnect = cache_downloading.containsKey(id);//̂Ƃdlǂ
		this.cache_contentLength = 0;
		this.cache_tmpSize = 0;
		this.cache_resource = Resource.get(Resource.Type.URL,this.cache_requestHeader.getURI());
		this.cache_inputStream = null;
		this.cache_fileOutputStream = null;
		this.cache_posifix = "";
		this.cache_resource.addTransferListener(this);
		this.cache_file = null;
		//tmpt@C݂
		if(allTmpCacheList.containsKey(this.cache_id + this.cache_fmt)){
			this.cache_file = allTmpCacheList.get(this.cache_id + this.cache_fmt);
			this.cache_tmpSize = this.cache_file.length();//t@C̃TCYtmp
			//TCY0ȊO dDL ܂ W[tO Ȃ
			if (this.cache_tmpSize != 0 && (this.cache_dupconnect || Boolean.getBoolean("resumeDownload"))) {
				this.cache_requestHeader.setMessageHeader("Range", "bytes=" + this.cache_tmpSize + "-");
				this.cache_inputStream = new BufferedInputStream(new FileInputStream(this.cache_file));
				this.cache_partial = true;
			}
		}
		//
	}
	//*******************************************************************************************************************
	/** Resourceԋp
	 * @return Resource
	 * @throws IOException
	 */
	private Resource getResource() throws IOException {
		//uEULbV֎~
		this.cache_resource.setResponseHeader("Cache-Control", "no-cache");
		return this.cache_resource;
	}
	/** AEgoEh烊NGXgwb_VXeĂяoB
	* @param responseHeader
	*/
	public void onResponseHeader(HttpResponseHeader responseHeader){
		String contenttype = responseHeader.getMessageHeader(HttpHeader.CONTENT_TYPE);
		//gq肳
		if(contenttype != null && contenttype.endsWith("x-flv")){//FLV
			this.cache_posifix = ".flv";
		}else{
			this.cache_posifix = ".mp4";
		}
		//W[ȊOp̏
		if(!this.cache_partial){
			this.cache_file = new File(cacheDir+FS,NLTMP + this.cache_id + this.cache_fmt + this.cache_title + this.cache_posifix);
		}
		//t@C肵̂
		this.cache_logname = this.cache_file.getName().replaceFirst("^" + NLTMP,"");
		//̃TCY
		this.cache_contentLength = responseHeader.getContentLength();
		//302-1Ȃ
		if (this.cache_contentLength <= 0) {
			this.cache_errorStatus = true;
		}
		//Xe[^XR[h𒲂ׂ
		int statusCode = responseHeader.getStatusCode();
		if (statusCode == 206) {//W[
			String rangeValue = responseHeader.getMessageHeader("Content-Range");
			Matcher m = CONTENT_RANGE_VALUE_PATTERN.matcher(rangeValue);
			if (m.find()) {
				if (Integer.parseInt(m.group(2)) + 1 == Integer.parseInt(m.group(3))) {
					//logInfo("Partial youtube download from " + m.group(1) + " byte");
				} else {
					//logInfo("Maybe Bad Responce: " + m.group(0));
				}
				this.cache_contentLength = Long.parseLong(m.group(3));//̃TCY
				this.cache_tmpSize = Integer.parseInt(m.group(1));//ꎞt@CTCY
				this.cache_partial = true;//W[tO
			}
			//W[Ȃ200ɂ
			responseHeader.setStatusCode(200, "OK");
			responseHeader.removeMessageHeader("Content-Range");
			responseHeader.removeMessageHeader("Accept-Range");
			responseHeader.setContentLength(this.cache_contentLength);
		} else if (statusCode == 416) {//W[s
			try {
				CloseUtil.close(this.cache_inputStream);
			} catch (Exception e) {
			}
			this.cache_errorStatus = true;
		} else if(statusCode == 302 || statusCode == 301){//ړĂ
			CloseUtil.close(this.cache_inputStream);
			this.cache_errorStatus = true;
			logWindow("no youtube cache found: Moved Temporarily (" + statusCode + ").");
			logWindow("Moved Location header: " + responseHeader.getMessageHeader("Location"));
		} else if (statusCode != 200){//Ȃɂ
			CloseUtil.close(this.cache_inputStream);
			this.cache_errorStatus = true;
		}
		//ȉAstatusCode200
		//󂫗eʂ̃`FbN wlȉTCY+100kbȉŒ~
		long freeSize = DiskFreeSpace.get(dareka.processor.impl.Cache.getCacheDir());
		long needSize = Long.getLong("needFreeSpace", 100) * 1024 * 1024;
		if (needSize != 0){
			if (freeSize < needSize || freeSize < this.cache_contentLength - this.cache_tmpSize + 100 * 1024) {
				logMulti(String.format("ceʂ %,d oCgȂ̂ŃLbV܂B", freeSize));
				this.cache_errorStatus = true;
			}
		}
		//
		try {
			//G[ĂȂ  dDLłȂ Ȃ
			if (!this.cache_errorStatus && !this.cache_dupconnect) {
				//FileOutputStream擾
				this.cache_fileOutputStream = new FileOutputStream(this.cache_file,this.cache_partial);
				//FileChannel擾
				cache_fileChannel = this.cache_fileOutputStream.getChannel();
			}
		} catch (IOException e) {
			this.cache_errorStatus = true;
		} catch (Exception e) {
			this.cache_errorStatus = true;
		}
		logWindow("movieType: /Content-Type: " + contenttype + ((this.cache_partial)?" /FileContentLength: " + this.cache_file.length() + " byte":"") + " /ContentLength: " + this.cache_contentLength + " byte");
		if(this.cache_errorStatus){//G[Ă
			//
		}else if(this.cache_dupconnect){//dDL
			logMulti("dup Connection youtube download found: " + this.cache_logname);
		}else if(this.cache_partial){//W[
			logWindow("Partial: /FileContentLength: " + String.format("%,d KByte",this.cache_file.length()/1024) + " /ContentLength: " + String.format("%,d KByte",this.cache_contentLength/1024) + " /dup: " + this.cache_dupconnect);
			logMulti("Partial youtube download found: " + this.cache_logname);
		}else if(!this.cache_errorStatus){//G[ĂȂ
			logWindow("nocache: /ContentLength: " + String.format("%,dK Byte",this.cache_contentLength/1024) + " /dup: " + this.cache_dupconnect);
			logMulti("no youtube cache found: " + this.cache_logname);
		}else{
			//ɂ͂Ȃ͂
		}
		//G[ĂȂ  ddlł͂Ȃ Ȃ
		if(!this.cache_errorStatus && !this.cache_dupconnect){
			//dlXgɉ
			cache_downloading.put(this.cache_id,this.cache_contentLength);
		}
	}
	/** f[^̓]n߂OɌĂяoB
	 * @param bout OutputStream
	 */
	public void onTransferBegin(OutputStream bout){
		//W[pɍLbVς݂̂̂uEUɑM
		if (this.cache_partial && this.cache_inputStream != null) {
			try {
				int len = 0;
				int rest = (int)this.cache_tmpSize;
				byte[] buf = new byte[32 * 1024];
				while ((len = this.cache_inputStream.read(buf)) != -1 && rest > 0) {
					try {
						bout.write(buf, 0, (len < rest) ? len : rest);
					} catch (IOException e) {
						this.cache_errorStatus = true;
					}
					rest -= len;
				}
			} catch (IOException e) {
				this.cache_errorStatus = true;
			} finally {
				if (CloseUtil.close(this.cache_inputStream) == false) {
					this.cache_errorStatus = true;
				}
			}
		}
	}
	/**
	 * AEgoEhCoEhɃf[^]邽тɃVXeĂяoB
	 * @param buf ]f[^B
	 * @param length buf̗̒Lȃf[^̒B
	 */
	public void onTransferring(byte[] buf, int length){
		//Ȃ񂩃G[Ȃ߂
		if (this.cache_errorStatus || this.cache_fileChannel == null) {
			return;
		}
		//t@Cɏ
		try {
			this.cache_fileChannel.write(ByteBuffer.wrap(buf, 0, length), this.cache_tmpSize);
			this.cache_tmpSize += length;
		} catch (IOException e) {
			this.cache_errorStatus = true;
		}
	}
	/**
	 * f[^̓]IVXeĂяoB
	 * @param completed Ō܂œ]łtrueBrŒfꍇA
	 * ͎ۂɓ]ꂽf[^ʂContent-LengthƈقȂꍇfalseB
	 */
	public void onTransferEnd(boolean completed){
		if (this.cache_dupconnect) {
			return;//dDLȂ
		}
		//_E[hXg폜
		cache_downloading.remove(this.cache_id);
		//idۑĂƂ납폜
		Matcher m = PATTERN_PROCESSOR_SUPPORTED.matcher(this.cache_requestHeader.getURI());
		if(m.find() && !this.cache_errorStatus && completed){
			//}b`{G[ĂȂ{rIł͂ȂȂ
			//uEUwatchy[WLbVĂ܂āA^CgȂƂ邽
			String iid = m.group(1) != null ? m.group(1) : m.group(2) != null ?  m.group(2) : m.group(3) != null ? m.group(3) : m.group(4);
			if(iid != null && !iid.equals("")){//ꉞnull`FbN
				//폜̂͑̂Ƃ
				//cacheid.remove(iid);
			}
		}
		//
		this.cache_requestHeader = null;
		this.cache_resource = null;
		this.cache_inputStream = null;
		try{
			if(this.cache_fileOutputStream != null){
				this.cache_fileOutputStream.close();
			}
			this.cache_fileOutputStream = null;
		}catch(IOException e){
			//
		}
		//I
		if(completed){
			//G[ĂȂ
			if(!this.cache_errorStatus){
				//O̕ύX
				if(!changeFileName(this.cache_file,new File(cacheDir+FS,this.cache_id + this.cache_fmt + this.cache_title + this.cache_posifix))){//O̕ύXłȂꍇ
					//ύXɎs̏ꍇAǂ邩B܂莸sȂ̂ŕu
				}
				logMulti("youtube cache completed: " + this.cache_logname);
			}
			this.cache_fileChannel = null;
			this.cache_file = null;
		}else{//LbVrŎ~܂
			try {
				if (this.cache_fileChannel != null) {
					this.cache_fileChannel.truncate(this.cache_tmpSize);//tmpSizẽTCYɐ؂
				}
			} catch (IOException e) {
				//
			}
			logMulti("youtube cache suspended: " + this.cache_logname);
			this.cache_file = null;
			this.cache_fileChannel = null;
		}
	}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
	/** ʃXbh */
	public void run(){
		FileOutputStream fout = null;
		try {
			URL url = new URL(this.cache_requestHeader.getURI());
			this.cache_requestHeader.setMessageHeader("Host", url.getHost());
			fout = new FileOutputStream(new File(File.separatorChar == '\\' ? "NUL" : "/dev/null"));
			URLResource r = new URLResource(this.cache_requestHeader.getURI());
			r.setFollowRedirects(true);// _CNgǐՂ
			try {
				r.setProxyMyself();
			} catch (NoSuchMethodError e) {
				r.setProxy("localhost", Integer.getInteger("listenPort"));
			}
			//r.addTransferListener(this);//addTransferListenerƓdɂȂ̂ŃRgAEg
			r.transferTo(null, fout, this.cache_requestHeader, null);
		} catch (IOException e) {
		} finally {
			CloseUtil.close(fout);
		}
		fout = null;
	}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
	/** mp4m4a
	 * @param id id
	 * @param cachePath CacheFile.getAbsolutePath()
	 * @param title
	 * @param requestHeader HttpRequestHeader
	 * @return Resource
	 */
	private Resource mp4box(String id,String cachePath,String title,HttpRequestHeader requestHeader) {
		String tmpdir = System.getProperty("java.io.tmpdir");
		String userAgent = requestHeader.getMessageHeader("User-Agent");
		File audioFile = null;
		int i = 0;
		do {
			audioFile = new File(tmpdir, "nlAudioExtractor" + (++i));
		} while (audioFile.exists());
		String audioPath = audioFile.getAbsolutePath();
		// AudiogbN肷
		String[] preArgs = { "MP4Box", cachePath, "-info" };
		BufferedReader preInputReader = execCommand(preArgs);
		if (preInputReader == null){
			return StringResource.getNotFound();
		}
		String tmpTrackNum = "2";
		String trackNum = "2";
		String infoLine = "";
		try {
			while((infoLine = preInputReader.readLine()) != null) {
				if (infoLine.indexOf("Track #") == 0) {
					tmpTrackNum = infoLine.substring(8, 9);
				} else if (infoLine.indexOf("Audio Stream") != -1) {
					trackNum = tmpTrackNum;
				}
			}
		} catch (IOException e) {
			//donot
		}
		String[] args = { "MP4Box", cachePath, "-single", trackNum, "-out", audioPath };
		execCommand(args);
		// [GUI] ÂMP4Box͏o̓t@CႤ߁Ãt@CmF
		audioFile = new File(audioPath + ".mp4");
		if (!audioFile.exists()) {
			audioFile = new File(audioPath + "_track" + trackNum + ".mp4");
		}
		audioPath = audioFile.getAbsolutePath();
		StringBuilder sb = new StringBuilder();
		for (String s : args) {
			if (sb.length() > 0) sb.append(" ");
			if (s.contains(" ")) sb.append('"');
			sb.append(s);
			if (s.contains(" ")) sb.append('"');
		}
		String commandLine = sb.toString();
		return createAudioResource(audioFile,userAgent,id,title,commandLine);
	}
	/** yt@CResource
	 * @param audioFile file
	 * @param userAgent User-Agent
	 * @param id id
	 * @param title title
	 * @param commandLine commandLine
	 * @return Resource
	 */
	private Resource createAudioResource(File audioFile,String userAgent,String id,String title,String commandLine) {
		// MP4Boxł͏o̓t@CɊgqsv
		String contentType = "audio/m4a";
		if (audioFile.length() > 0) {
			try {
				Resource r = new TemporaryFileResource(audioFile);
				r.setResponseHeader(HttpHeader.CONTENT_TYPE, contentType);
				String downloadName = "";
				setContentDisposition(r,userAgent,id,title);
				return r; // SUCCESS
			} catch (IOException e) {
				//Logger.error(e);
			}
		} else {
			//logInfo("Cannot extract audio. Check the following command line:");
			//Logger.info(" -> "+commandLine);
		}
		audioFile.delete();
		return StringResource.getNotFound();
	}
	/** mp4boxɂR}h
	 * @param args IvV
	 * @return R}hBufferedReader
	 */
	private BufferedReader execCommand(String[] args) {
		StringBuilder sb = new StringBuilder();
		for (String s : args) {
			if (sb.length() > 0) sb.append(" ");
			if (s.contains(" ")) sb.append('"');
			sb.append(s);
			if (s.contains(" ")) sb.append('"');
		}
		String commandLine = sb.toString();
		//Logger.debug(commandLine);
		sb.delete(0, sb.length());
		Process proc = null;
		BufferedReader in = null;
		try {
			proc = Runtime.getRuntime().exec(args);
			in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
			String line;
			while((line = in.readLine()) != null) {
				sb.append(line);
				sb.append('\n');
			}
			proc.waitFor();
		} catch (IOException e) {
			//info("Needs `"+args[0]+"' command to extract audio.");
			return null;
		} catch (InterruptedException e) {
			//Logger.error(e);
		} finally {
			if (proc != null) {
				CloseUtil.close(in);
				CloseUtil.close(proc.getOutputStream());
				CloseUtil.close(proc.getErrorStream());
				proc.destroy();
			}
		}
		String commandOut = sb.toString();
		//Logger.debug(commandOut);
		return new BufferedReader(new StringReader(commandOut));
	}
	/** _E[hɓ^Cg
	 * @param r Resource
	 * @param userAgent userAgent
	 * @param downloadName ^CgȂƂ͂g
	 * @param title ^Cg
	 */
	public static void setContentDisposition(Resource r, String userAgent, String downloadName,String title) {
		String ext = ".m4a";
		// _E[hɓ^Cg
		if (Boolean.getBoolean("useDownloadCacheName") && userAgent != null) {
			if (userAgent.contains("MSIE") || userAgent.contains("Chrome")) {
				r.setHeaderEncode("MS932");
				if (ext.equals(".mp3")) {
				//	downloadName = title;
				//	if (userAgent.contains("MSIE")) {//Chromemp3͏Ɋgq̂ŁAȂɂȂƃ_u
				//		downloadName += ext;
				//	}
				} else {
					downloadName = title + ext;
				}
			} else if (!userAgent.contains("Safari")) {
				r.setHeaderEncode("UTF-8");
				downloadName = title + ext;
			}
		}
		r.setResponseHeader("Content-Disposition","attachment; filename=\"" + downloadName + "\"");
	}
	//*******************************************************************************************************************
	// }f
	//*******************************************************************************************************************
	/** UNIXTIME`ϊ܂ (I[o[[hp)
	 * @param time UNIXTIME
	 * @param type o͌`
	 * @return ϊ
	 */
	private String convertUnixtime(String time,Integer type){
		return convertUnixtime(parseStringLong(time),type);
	}
	/** UNIXTIME`ϊ܂ (I[o[[hp)
	 * @param time UNIXTIME
	 * @return ϊ
	 */
	private String convertUnixtime(Long time){
		return convertUnixtime(time,1);
	}
	/** UNIXTIME`ϊ܂
	 * @param time UNIXTIME
	 * @param type o͌`
	 * @return ϊ
	 */
	private String convertUnixtime(Long time,Integer type){
		SimpleDateFormat sdf1 = null;
		if(type == null || type == 0){
			sdf1 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		}else if(type == 1){
			sdf1 = new SimpleDateFormat("yy/MM/dd HH:mm:ss");
		}else{
			sdf1 = new SimpleDateFormat("HH:mm:ss");
		}
		Date date = new Date();
		if(time !=null && time > 0){
			date = new Date(time*1000);
		}
		return sdf1.format(date);
	}
	/** UTF-8ŃfR[hA(I[o[[hp)
	 * @param word 
	 * @return fR[h
	 */
	private String convertURLDecoder(String word){
		return convertURLDecoder(word,"UTF-8");
	}
	/** fR[h(I[o[[hp)
	 * @param word 
	 * @param enc R[h
	 * @return fR[h
	 */
	private String convertURLDecoder(String word,String enc){
		String str = null;
		try{
			str = URLDecoder.decode(word,enc);
		}catch(java.io.UnsupportedEncodingException e){
			str = null;
		}
		return str;
	}
	/** UTF-8ŃGR[hA(I[o[[hp)
	 * @param word 
	 * @return GR[h
	 */
	private String convertURLEncoder(String word){
		return convertURLEncoder(word,"UTF-8");
	}
	/** GR[h(I[o[[hp)
	 * @param word 
	 * @param enc R[h
	 * @return GR[h
	 */
	private String convertURLEncoder(String word,String enc){
		String str = null;
		try{
			str = URLEncoder.encode(word,enc);
		}catch(java.io.UnsupportedEncodingException e){
			str = null;
		}
		return str;
	}
	/** 𐔎ɕϊ
	 * @param word ϊ镶
	 * @return ϊ
	 */
	private int parseStringInt(String word) {
		try{
			return Integer.parseInt(word);
		} catch (NumberFormatException e) {
			return 0;
		}
	}
	/** 𐔎ɕϊ
	 * @param word ϊ镶
	 * @return ϊ
	 */
	private Integer parseStringInteger(String word) {
		try{
			return Integer.parseInt(word);
		} catch (NumberFormatException e) {
			return 0;
		}
	}
	/** 𐔎ɕϊ
	 * @param word ϊ镶
	 * @return ϊ
	 */
	private Long parseStringLong(String word) {
		try{
			return Long.parseLong(word);
		} catch (NumberFormatException e) {
			return 0l;
		}
	}
	/**
	 * http̉ԋp
	 * @param url URL
	 * @param requestHeader HttpRequestHeader
	 * @param nlflag nlʂǂ true ʂ false ʂȂ
	 * @return http̓e
	 */
	private String getHttpRespons(String url,HttpRequestHeader requestHeader,Boolean nlflag){
		try{
			URLResource r = new URLResource(url);
			r.setFollowRedirects(true);// _CNgǐՂ
			HttpRequestHeader header = new HttpRequestHeader(HttpHeader.GET + " " + url + " HTTP/1.0\r\n\r\n");
			header.setMessageHeader("Accept", "*/*");
			header.setMessageHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; ja; rv:1.9.1.6) Gecko/20091201 Firefox/3.5.6 (.NET CLR 3.5.30729)");
			header.setMessageHeader("Connection", "Keep-Alive");
			header.setMessageHeader("Pragma", "no-cache");
			header.setMessageHeader("Cookie", requestHeader.getMessageHeader("Cookie"));
			ByteArrayOutputStream bout = new ByteArrayOutputStream();
			if(nlflag){
				try {
					r.setProxyMyself(); // swfConvert07bȍ~
				} catch (NoSuchMethodError e) {
					r.setProxy("localhost", Integer.getInteger("listenPort"));
				}
			}
			r.transferTo(null, bout, header, null);
			ByteArrayInputStream bin = new ByteArrayInputStream(bout.toByteArray());
			HttpResponseHeader responseHeader = new HttpResponseHeader(bin);
			byte[] bcontent = new byte[bin.available()];
			bin.read(bcontent, 0, bin.available());
			if (responseHeader.getStatusCode() == 404) {
				logWindow("getHttpRespons: " + url + " [404] @" + nlflag);
				return "404";
			}else if (responseHeader.getStatusCode() != 200) {
				logWindow("getHttpRespons: " + url + " [NG] @" + nlflag);
				return "NG";
			}
			logWindow("getHttpRespons: " + url + " @" + nlflag);
			return new String(bcontent, "utf-8");
		}catch(Exception e){
			return "";
		}
	}
	/** t@Cɏރ\bh
	 * @param str ݕ
	 */
	private void fileWriter(String str){
		new File("list").mkdir();//XgtH_쐬
		OutputStreamWriter fw = null;
		try {
			fw = new OutputStreamWriter(new FileOutputStream(YCIdFile,false), "UTF8");//true-ǋL[h
			fw.write(str);
		} catch (IOException e) {
		} finally {
			CloseUtil.close(fw);
		}
	}
	/** R[h𒲂ׂ(nlRsy)
	 * @param file t@C
	 * @return R[h
	 */
	private String checkCharCode(File file) {
		String CHARTEST_LINE = "<!-- 悤׃LbV -->";
		String[] charSet = {"MS932", "UTF-8", "EUC-JP"};
// ŏ̍s當R[h𔻒肵Ă݂
// Ƃ肠ŏǂł݂
		byte[] bBuf = new byte[256];
		BufferedInputStream bin = null;
		String charCode = null;
		try {
			bin = new BufferedInputStream(new FileInputStream(file));
			int index = 0;
			while((index += bin.read(bBuf, index, 255-index)) != -1 && index < 255);
			if (bBuf[0] == (byte)0xEF && bBuf[1] == (byte)0xBB && bBuf[2] == (byte)0xBF) {
				charCode = "UTF-8";// BOMtȂUTF-8
			} else {// fR[hē̕񂪊܂܂邩
				for (String testCode: charSet) {
					String testString = new String(bBuf, testCode);
					if (testString.startsWith(CHARTEST_LINE)) {
						charCode = testCode;
						break;
					}
				}
			}
		} catch (IOException e) {
			//Logger.error(e);
		} finally {
			CloseUtil.close(bin);
		}
		return charCode;
	}
	//*******************************************************************************************************************
	//*******************************************************************************************************************
}
